#
# spec file for package openssl1
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#



Name:           openssl1
BuildRequires:  bc
BuildRequires:  ed
BuildRequires:  pkg-config
BuildRequires:  zlib-devel
%define ssletcdir %{_sysconfdir}/ssl
#%define num_version %(echo "%{version}" | sed -e "s+[a-zA-Z]++g; s+_.*++g")
%define num_version 1.0.0
Provides:       ssl
Version:        1.0.1g
Release:        0.30.1
Summary:        Secure Sockets and Transport Layer Security
License:        OpenSSL
Group:          Productivity/Networking/Security
Url:            http://www.openssl.org/
Source:         http://www.openssl.org/source/openssl-%{version}.tar.gz
Source42:       http://www.openssl.org/source/openssl-%{version}.tar.gz.asc
# https://www.openssl.org/about/
Source43:       http://pgp.mit.edu:11371/pks/lookup?op=get&search=0xA2D29B7BF295C759#/%name.keyring
# to get mtime of file:
Source1:        openssl1.changes
Source2:        baselibs.conf
Source10:       README.SUSE
Patch0:         merge_from_0.9.8k.patch
Patch1:         openssl-1.0.0-c_rehash-compat.diff
Patch2:         bug610223.patch
Patch3:         openssl-ocloexec.patch
Patch4:         VIA_padlock_support_on_64systems.patch
# PATCH-FIX-UPSTREAM http://rt.openssl.org/Ticket/Attachment/WithHeaders/20049
Patch5:         openssl-fix-pod-syntax.diff
# new truststore for SLE12, not needed in SLE11.
#Patch6:         openssl-1.0.1e-truststore.diff
Patch7:         compression_methods_switch.patch
Patch8:         0005-libssl-Hide-library-private-symbols.patch
Patch9:         openssl-1.0.1c-default-paths.patch
Patch10:        openssl-pkgconfig.patch
# From Fedora openssl.
Patch13:        openssl-1.0.1c-ipv6-apps.patch
Patch14:        0001-libcrypto-Hide-library-private-symbols.patch

# FIPS patches left out

Patch19:        bug-860332-cmdline-check-certs.patch
Patch22:        CVE-2010-5298.patch
Patch23:        CVE-2014-0198.patch
Patch24:        CVE-2014-3470.patch
Patch25:        CVE-2014-0221.patch
Patch26:        CVE-2014-0224.patch
Patch27:        CVE-2014-0195.patch
Patch28:        openssl-CVE-2014-3505.patch
Patch29:        openssl-CVE-2014-3506.patch
Patch30:        openssl-CVE-2014-3507.patch
Patch31:        openssl-CVE-2014-3508.patch
Patch32:        openssl-CVE-2014-3509.patch
Patch33:        openssl-CVE-2014-3510.patch
Patch34:        openssl-CVE-2014-3511.patch
Patch35:        openssl-CVE-2014-3512.patch
Patch36:        openssl-CVE-2014-5139.patch
Patch37:        openssl1-CVE-2014-3513.patch
Patch38:        openssl1-CVE-2014-3566.patch
Patch39:        openssl1-CVE-2014-3567.patch
Patch40:        openssl1-CVE-2014-3568.patch
Patch41:        openssl-Added-OPENSSL_NO_EC2M-guards-around-the-preferred-EC.patch
Patch45:        openssl-CVE-2014-3572.patch
Patch46:        openssl-CVE-2014-8275.patch
Patch47:        openssl-CVE-2015-0204.patch
Patch48:        openssl-CVE-2015-0205.patch
Patch49:        openssl-CVE-2015-0206.patch
Patch50:        openssl-CVE-2014-3570.patch
Patch51:        openssl-CVE-2014-3571.patch
Patch52:        openssl-CVE-2015-0209.patch
Patch53:        openssl-CVE-2015-0286.patch
Patch54:        openssl-CVE-2015-0287.patch
Patch55:        openssl-CVE-2015-0288.patch
Patch56:        openssl-CVE-2015-0289.patch
Patch57:        openssl-CVE-2015-0293.patch
Patch58:        openssl-CVE-2015-0292.patch
Patch59:        openssl-add_option_to_disable_padding_extension.patch
Patch67:        openssl-CVE-2014-8176.patch
Patch68:        openssl-RSA_premaster_secret_in_constant_time.patch
Patch69:        openssl-CVE-2015-1788.patch
Patch70:        openssl-CVE-2015-1789.patch
Patch71:        openssl-CVE-2015-1790.patch
Patch72:        openssl-CVE-2015-1791.patch
Patch73:        openssl-CVE-2015-1792.patch
# CVE-2015-4000 fixes (aka Logjam, weakdh.org)
Patch74:        0001-s_server-Use-2048-bit-DH-parameters-by-default.patch
Patch75:        0002-dhparam-set-the-default-to-2048-bits.patch
Patch76:        0003-dhparam-fix-documentation.patch
Patch77:        0004-Update-documentation-with-Diffie-Hellman-best-practi.patch
Patch78:        0005-client-reject-handshakes-with-DH-parameters-1024-bits.patch
# EO CVE-2015-4000
Patch79:        0001-bn-asm-s390x.S-improve-performance-on-z196-and-z13-b.patch
Patch80:        openssl-CVE-2015-3194.patch
Patch81:        openssl-CVE-2015-3195.patch
Patch82:        openssl-CVE-2015-3196.patch
Patch83:        openssl-CVE-2015-3197.patch
Patch84:        openssl-avoid-config-twice.patch
# OpenSSL Security Advisory [1st March 2016]
Patch85:        openssl-CVE-2016-0702-openssl101.patch
Patch86:        openssl-CVE-2016-0705.patch
Patch87:        openssl-CVE-2016-0797.patch
Patch88:        openssl-CVE-2016-0798-101.patch
Patch89:        openssl-CVE-2016-0799.patch
Patch90:        openssl-CVE-2016-0800-DROWN-disable-ssl2.patch
# OpenSSL Security Advisory [3rd May 2016]
Patch91:        openssl-CVE-2016-2107.patch
Patch92:        openssl-CVE-2016-2108.patch
Patch93:        openssl-CVE-2016-2109.patch
Patch94:        openssl-CVE-2016-2105.patch
Patch95:        openssl-CVE-2016-2106.patch
Patch96:        0001-Preserve-digests-for-SNI.patch
Patch97:        0001-Fix-buffer-overrun-in-ASN1_parse.patch

# SLE11 shadow ssl1
Patch100:       openssl1-opt-suse.patch
# let c_rehash1 call openssl1
Patch101:       openssl1-c_rehash.patch

Patch110:       openssl-s390x_performance_improvements.patch
Patch111:       openssl-update-expired-smime-certs.patch
Patch112:       openssl-print_notice-NULL_crash.patch

#OpenSSL Security Advisory [22 Sep 2016] (bsc#999665)
Patch120:       openssl-CVE-2016-2177.patch
Patch121:       openssl-CVE-2016-2178.patch
Patch122:       openssl-CVE-2016-2180.patch
Patch123:       openssl-CVE-2016-2182.patch
Patch124:       openssl-CVE-2016-2181.patch
Patch125:       openssl-CVE-2016-2179.patch
Patch126:       openssl-CVE-2016-6303.patch
Patch127:       openssl-CVE-2016-2183-SWEET32.patch
Patch128:       openssl-CVE-2016-6306.patch
Patch129:       openssl-CVE-2016-6304.patch
Patch130:       openssl-CVE-2016-6302.patch
Patch131:       openssl-randfile_fread_interrupt.patch
# OpenSSL Security Advisory [26 Jan 2017] (bsc#1021641)
Patch133:       openssl-CVE-2016-8610.patch
Patch134:       openssl-CVE-2016-7056.patch
Patch136:       openssl-fix_crash_in_openssl_speed.patch
Patch137:       openssl-degrade_3DES_to_MEDIUM_in_SSL2.patch
Patch138:       openssl-CVE-2017-3731.patch
# OpenSSL Security Advisory [28 Aug 2017]
Patch139:       openssl-CVE-2017-3735.patch
Patch140:       openssl-fix_crash_in_DES.patch
Patch141:       0001-Backport-support-for-fixed-DH-ciphersuites-from-HEAD.patch
Patch142:       0001-Don-t-send-a-for-ServerKeyExchange-for-kDHr-and-kDHd.patch
Patch143:       openssl-DH_fix_logjam.patch
Patch144:       openssl-1.0.1i-trusted-first.patch
Patch145:       openssl-1.0.1i-alt-chains.patch
# add DEFAULT_SUSE cipher list
Patch146:       openssl-1.0.1e-add-test-suse-default-cipher-suite.patch
Patch147:       openssl-1.0.1e-add-suse-default-cipher-header.patch
Patch148:       openssl-1.0.1e-add-suse-default-cipher.patch
# OpenSSL Security Advisory [27 Mar 2018]
Patch149:       openssl-CVE-2018-0739.patch
# OpenSSL Security Advisory [12 June 2018]
# bsc#1097158
Patch150:       openssl-CVE-2018-0732.patch
# bsc#1097624
Patch151:       openssl-add-blinding-to-ecdsa.patch
# bsc#1098592
Patch152:       openssl-add-blinding-to-dsa.patch
# OpenSSL Security Advisory [16 Apr 2018]
Patch153:       openssl-CVE-2018-0737.patch
Patch155:       openssl-One_and_Done.patch
# OpenSSL Security Advisory [30 October 2018]
Patch156:       0001-DSA-Address-a-timing-side-channel-whereby-it-is-possible.patch
Patch157:       0002-ECDSA-Address-a-timing-side-channel-whereby-it-is-possible.patch
Patch158:       openssl-CVE-2018-0734.patch
Patch159:       0001-Merge-to-1.0.2-DSA-mod-inverse-fix.patch
Patch160:       0001-Add-a-constant-time-flag-to-one-of-the-bignums-to-av.patch
Patch161:       openssl-CVE-2018-5407-PortSmash.patch
# The 9 Lives of Bleichenbacher's CAT - vulnerability #7739
# https://github.com/openssl/openssl/pull/6889
Patch162:       openssl-Extended-OAEP-support.patch
Patch163:       openssl-rewrite-RSA-padding-checks.patch
Patch164:       openssl-add-computationally-constant-time-bn_bn2binpad.patch
Patch165:       openssl-address-Coverity-nit-in-bn2binpad.patch
Patch166:       openssl-switch-to-BN_bn2binpad.patch
# https://github.com/openssl/openssl/pull/6942
Patch167:       0001-crypto-bn-add-more-fixed-top-routines.patch
Patch168:       0002-rsa-rsa_eay.c-implement-variant-of-Smooth-CRT-RSA.patch
Patch169:       0003-bn-bn_blind.c-use-Montgomery-multiplication-when-pos.patch
Patch170:       0004-bn-bn_lib.c-conceal-even-memmory-access-pattern-in-b.patch
# https://github.com/openssl/openssl/pull/7737
Patch171:       0005-err-err.c-add-err_clear_last_constant_time.patch
Patch172:       0006-rsa-rsa_eay.c-make-RSAerr-call-in-rsa_ossl_private_d.patch
Patch173:       0007-rsa-rsa_pk1.c-remove-memcpy-calls-from-RSA_padding_c.patch
Patch174:       0008-rsa-rsa_oaep.c-remove-memcpy-calls-from-RSA_padding_.patch
Patch175:       0009-rsa-rsa_ssl.c-make-RSA_padding_check_SSLv23-constant.patch
Patch176:       openssl-bn_mul_mont_fixed_top.patch
Patch177:       openssl-bn_mod_add_fixed_top.patch
Patch178:       0001-RT-4242-reject-invalid-EC-point-coordinates.patch
Patch179:       openssl-CVE-2019-1559.patch
# OpenSSL Security Advisory [10 September 2019]
Patch180:       openssl-CVE-2019-1547.patch
Patch181:       openssl-CVE-2019-1563.patch
# PATCH-FIX-UPSTREAM bsc#1160163 Fix missing BN_copy()
Patch182:       openssl-add-BN_FLG_FIXED_TOP-flag.patch
# PATCH-FIX-UPSTREAM bsc#1117951 bsc#1160163 Add missing commits
Patch183:       openssl-add-missing-commits-for-bsc1117951.patch
# OpenSSL Security Advisory [09 September 2020]
Patch184:       openssl-CVE-2020-1968-raccoon.patch
# OpenSSL Security Advisory [8 December 2020] bsc#1179491 CVE-2020-1971
Patch185:       openssl-CVE-2020-1971.patch
# OpenSSL Security Advisory [16 February 2021] [bsc#1182333,CVE-2021-23840] [bsc#1182331,CVE-2021-23841]
Patch186:       openssl-CVE-2021-23840.patch
Patch187:       openssl-CVE-2021-23841.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, full-featured, and open source toolkit implementing
the Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS
v1) protocols with full-strength cryptography. The project is managed
by a worldwide community of volunteers that use the Internet to
communicate, plan, and develop the OpenSSL toolkit and its related
documentation.

Derivation and License

OpenSSL is based on the excellent SSLeay library developed by Eric A.
Young and Tim J. Hudson. The OpenSSL toolkit is licensed under an
Apache-style license, which basically means that you are free to get it
and to use it for commercial and noncommercial purposes.

%package -n libopenssl1_0_0


Summary:        Secure Sockets and Transport Layer Security
Group:          Productivity/Networking/Security
Recommends:     openssl-certs
Requires:       openssl1
Provides:       cipher(openssl1:DEFAULT_SUSE)
#

%description -n libopenssl1_0_0
The OpenSSL Project is a collaborative effort to develop a robust,
commercial-grade, full-featured, and open source toolkit implementing
the Secure Sockets Layer (SSL v2/v3) and Transport Layer Security (TLS
v1) protocols with full-strength cryptography. The project is managed
by a worldwide community of volunteers that use the Internet to
communicate, plan, and develop the OpenSSL toolkit and its related
documentation.

Derivation and License

OpenSSL is based on the excellent SSLeay library developed by Eric A.
Young and Tim J. Hudson. The OpenSSL toolkit is licensed under an
Apache-style license, which basically means that you are free to get it
and to use it for commercial and noncommercial purposes.

%package -n libopenssl1-devel


Summary:        Include Files and Libraries mandatory for Development
Group:          Development/Libraries/C and C++
Requires:       %name = %version
Requires:       libopenssl1_0_0 = %{version}
Requires:       zlib-devel
Provides:       libopenssl-devel = %{version}
Provides:       openssl-devel = %{version}
Conflicts:      libopenssl-devel < 1.0.1

%description -n libopenssl1-devel
This package contains all necessary include files and libraries needed
to develop applications that require these.

%package doc


Summary:        Additional Package Documentation
Group:          Productivity/Networking/Security
%if 0%{?suse_version} >= 1140
BuildArch:      noarch
%endif
Conflicts:      openssl-doc

%description doc
This package contains optional documentation provided in addition to
this package's base documentation.

%prep
%setup -q  -n openssl-%version
%patch0 -p1
%patch1 -p1
#%patch2 -p1
%patch3
%patch4 -p1
%patch5 -p1
#patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch13 -p1
%patch14 -p1

%patch19 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch41 -p1
%patch45 -p1
%patch46 -p1
%patch47 -p1
%patch48 -p1
%patch49 -p1
%patch50 -p1
%patch51 -p1
%patch52 -p1
%patch53 -p1
%patch54 -p1
%patch55 -p1
%patch56 -p1
%patch57 -p1
%patch58 -p1
%patch59 -p1
%patch67 -p1
%patch68 -p1
%patch69 -p1
%patch70 -p1
%patch71 -p1
%patch72 -p1
%patch73 -p1
%patch74 -p1
%patch75 -p1
%patch76 -p1
%patch77 -p1
%patch78 -p1
%patch79 -p1
%patch80 -p1
%patch81 -p1
%patch82 -p1
%patch83 -p1
%patch84 -p1
%patch85 -p1
%patch86 -p1
%patch87 -p1
%patch88 -p1
%patch89 -p1
%patch90 -p1
%patch91 -p1
%patch92 -p1
%patch93 -p1
%patch94 -p1
%patch95 -p1
%patch96 -p1
%patch97 -p1

# sle11 override specific adjustments
%patch100 -p1
%patch101 -p1

# delete patch leftovers from doc to silence a build check
find doc -name \*.orig -delete

%patch110 -p1
%patch111 -p1
%patch112 -p1
#OpenSSL Security Advisory [22 Sep 2016] (bsc#999665)
%patch120 -p1
%patch121 -p1
%patch122 -p1
%patch123 -p1
%patch124 -p1
%patch125 -p1
%patch126 -p1
%patch127 -p1
%patch128 -p1
%patch129 -p1
%patch130 -p1
%patch131 -p1
%patch133 -p1
%patch134 -p1
%patch136 -p1
%patch137 -p1
%patch138 -p1
%patch139 -p1
%patch140 -p1
%patch141 -p1
%patch142 -p1
%patch143 -p1
%patch144 -p1
%patch145 -p1
%patch146 -p1
%patch147 -p1
%patch148 -p1
%patch149 -p1
%patch150 -p1
%patch151 -p1
%patch152 -p1
%patch153 -p1
%patch155 -p1
%patch156 -p1
%patch157 -p1
%patch158 -p1
%patch159 -p1
%patch160 -p1
%patch161 -p1
%patch162 -p1
%patch163 -p1
%patch164 -p1
%patch165 -p1
%patch166 -p1
%patch167 -p1
%patch168 -p1
%patch169 -p1
%patch170 -p1
%patch171 -p1
%patch172 -p1
%patch173 -p1
%patch174 -p1
%patch175 -p1
%patch176 -p1
%patch177 -p1
%patch178 -p1
%patch179 -p1
%patch180 -p1
%patch181 -p1
%patch182 -p1
%patch183 -p1
%patch184 -p1
%patch185 -p1
# OpenSSL Security Advisory [16 February 2021]
%patch186 -p1
%patch187 -p1

# clean up patching leftovers
find . -name '*.orig' -delete

cp -p %{S:10} .
echo "adding/overwriting some entries in the 'table' hash in Configure"
# $dso_scheme:$shared_target:$shared_cflag:$shared_ldflag:$shared_extension:$ranlib:$arflags
export DSO_SCHEME='dlfcn:linux-shared:-fPIC::.so.\$(SHLIB_MAJOR).\$(SHLIB_MINOR)::'
cat <<EOF_ED | ed -s Configure 
/^);
-
i
#
# local configuration added from specfile
# ... MOST of those are now correct in openssl's Configure already, 
# so only add them for new ports!
#
#config-string,  $cc:$cflags:$unistd:$thread_cflag:$sys_id:$lflags:$bn_ops:$cpuid_obj:$bn_obj:$des_obj:$aes_obj:$bf_obj:$md5_obj:$sha1_obj:$cast_obj:$rc4_obj:$rmd160_obj:$rc5_obj:$wp_obj:$cmll_obj:$dso_scheme:$shared_target:$shared_cflag:$shared_ldflag:$shared_extension:$ranlib:$arflags:$multilib
#"linux-elf",    "gcc:-DL_ENDIAN			::-D_REENTRANT::-ldl:BN_LLONG \${x86_gcc_des} \${x86_gcc_opts}:\${x86_elf_asm}:$DSO_SCHEME:",
#"linux-ia64",   "gcc:-DL_ENDIAN	-DMD32_REG_T=int::-D_REENTRANT::-ldl:SIXTY_FOUR_BIT_LONG RC4_CHUNK RC4_CHAR:\${ia64_asm}:		$DSO_SCHEME:",
#"linux-ppc",    "gcc:-DB_ENDIAN			::-D_REENTRANT::-ldl:BN_LLONG RC4_CHAR RC4_CHUNK DES_RISC1 DES_UNROLL:\${no_asm}:		$DSO_SCHEME:",
#"linux-ppc64",  "gcc:-DB_ENDIAN -DMD32_REG_T=int::-D_REENTRANT::-ldl:RC4_CHAR RC4_CHUNK DES_RISC1 DES_UNROLL SIXTY_FOUR_BIT_LONG:\${no_asm}:	$DSO_SCHEME:64",
"linux-elf-arm","gcc:-DL_ENDIAN			::-D_REENTRANT::-ldl:BN_LLONG:\${no_asm}:							$DSO_SCHEME:",
"linux-mips",   "gcc:-DB_ENDIAN			::-D_REENTRANT::-ldl:BN_LLONG RC4_CHAR RC4_CHUNK DES_RISC1 DES_UNROLL:\${no_asm}:		$DSO_SCHEME:",
"linux-sparcv7","gcc:-DB_ENDIAN			::-D_REENTRANT::-ldl:BN_LLONG RC4_CHAR RC4_CHUNK DES_UNROLL BF_PTR:\${no_asm}:			$DSO_SCHEME:",
#"linux-sparcv8","gcc:-DB_ENDIAN -DBN_DIV2W -mv8	::-D_REENTRANT::-ldl:BN_LLONG RC4_CHAR RC4_CHUNK DES_UNROLL BF_PTR::asm/sparcv8.o:::::::::::::	$DSO_SCHEME:",
#"linux-x86_64", "gcc:-DL_ENDIAN -DNO_ASM -DMD32_REG_T=int::-D_REENTRANT::-ldl:SIXTY_FOUR_BIT_LONG:\${no_asm}:						$DSO_SCHEME:64",
#"linux-s390",   "gcc:-DB_ENDIAN			::(unknown):   :-ldl:BN_LLONG:\${no_asm}:							$DSO_SCHEME:",
#"linux-s390x",  "gcc:-DB_ENDIAN -DNO_ASM -DMD32_REG_T=int::-D_REENTRANT::-ldl:SIXTY_FOUR_BIT_LONG:\${no_asm}:					$DSO_SCHEME:64",
"linux-parisc",	"gcc:-DB_ENDIAN 		::-D_REENTRANT::-ldl:BN_LLONG RC4_CHAR DES_PTR DES_UNROLL DES_RISC1:\${no_asm}:			$DSO_SCHEME:",
.
wq
EOF_ED
# fix ENGINESDIR path
sed -i 's,/.libdir\/engines,/%_libdir/engines1,' Configure
grep engines Configure
# Record mtime of changes file instead of build time
CHANGES=`stat --format="%y" %SOURCE1`
sed -i -e "s|#define DATE \(.*\).LC_ALL.*date.|#define DATE \1$CHANGES|" crypto/Makefile

%build
%ifarch armv5el armv5tel
export MACHINE=armv5el
%endif
%ifarch armv6l armv6hl
export MACHINE=armv6l
%endif
./config --test-sanity 
#
config_flags="threads shared no-rc5 no-idea \
%ifarch x86_64 
enable-ec_nistp_64_gcc_128 \
%endif
no-ec2m \
enable-camellia \
zlib \
--prefix=%{_prefix} \
--libdir=%{_lib} \
--openssldir=%{ssletcdir} \
$RPM_OPT_FLAGS -O3 -std=gnu99 \
-Wa,--noexecstack \
-fomit-frame-pointer \
-DTERMIO \
-DPURIFY \
-D_GNU_SOURCE \
$(getconf LFS_CFLAGS) \
%ifnarch hppa aarch64
-Wall \
-fstack-protector "
%else
-Wall "
%endif
#
#%{!?do_profiling:%define do_profiling 0}
#%if %do_profiling
#	# generate feedback
#	./config $config_flags
#	make depend CC="gcc %cflags_profile_generate"
#	make CC="gcc %cflags_profile_generate"
#	LD_LIBRARY_PATH=`pwd` make rehash CC="gcc %cflags_profile_generate"
#	LD_LIBRARY_PATH=`pwd` make test CC="gcc %cflags_profile_generate"
#	LD_LIBRARY_PATH=`pwd` apps/openssl speed
#	make clean
#	# compile with feedback
#	# but not if it makes a cipher slower:
#	#find crypto/aes -name '*.da' | xargs -r rm
#	./config $config_flags %cflags_profile_feedback
#	make depend
#	make
#	LD_LIBRARY_PATH=`pwd` make rehash
#	LD_LIBRARY_PATH=`pwd` make test
#%else
# OpenSSL relies on uname -m (not good). Thus that little sparc line.
	./config \
%ifarch sparc64
		linux64-sparcv9 \
%endif
		$config_flags
	make depend
	make
	LD_LIBRARY_PATH=`pwd` make rehash
	%ifnarch armv4l
	LD_LIBRARY_PATH=`pwd` make test
	%endif
#%endif
# show settings
make TABLE
echo $RPM_OPT_FLAGS
eval $(egrep PLATFORM='[[:alnum:]]' Makefile)
grep -B1 -A22 "^\*\*\* $PLATFORM$" TABLE 

%install
rm -rf $RPM_BUILD_ROOT
make MANDIR=%{_mandir} INSTALL_PREFIX=$RPM_BUILD_ROOT install
install -d -m755 $RPM_BUILD_ROOT%{ssletcdir}/certs
ln -sf ./openssl $RPM_BUILD_ROOT/%{_includedir}/ssl
mkdir $RPM_BUILD_ROOT/%{_datadir}/ssl
mv $RPM_BUILD_ROOT/%{ssletcdir}/misc $RPM_BUILD_ROOT/%{_datadir}/ssl/
# ln -s %{ssletcdir}/certs 	$RPM_BUILD_ROOT/%{_datadir}/ssl/certs
# ln -s %{ssletcdir}/private 	$RPM_BUILD_ROOT/%{_datadir}/ssl/private
# ln -s %{ssletcdir}/openssl.cnf 	$RPM_BUILD_ROOT/%{_datadir}/ssl/openssl.cnf
#

#
# avoid file conflicts with man pages from other packages

pushd $RPM_BUILD_ROOT/%{_mandir}
# some man pages now contain spaces. This makes several scripts go havoc, among them /usr/sbin/Check.
# replace spaces by underscores
#for i in man?/*\ *; do mv -v "$i" "${i// /_}"; done
which readlink &>/dev/null || function readlink { ( set +x; target=$(file $1 2>/dev/null); target=${target//* }; test -f $target && echo $target; ) }
for i in man?/*; do 
	if test -L $i ; then
	    LDEST=`readlink $i`
	    rm -f $i ${i}ssl1
	    ln -sf ${LDEST}ssl1 ${i}ssl1
	else
	    mv $i ${i}ssl1
        fi
	case `basename ${i%.*}` in 
	    asn1parse|ca|config|crl|crl2pkcs7|crypto|dgst|dhparam|dsa|dsaparam|enc|gendsa|genrsa|nseq|openssl|passwd|pkcs12|pkcs7|pkcs8|rand|req|rsa|rsautl|s_client|s_server|smime|spkac|ssl|verify|version|x509)
		# these are the pages mentioned in openssl(1). They go into the main package.
		echo %doc %{_mandir}/${i}ssl1.gz >> $OLDPWD/filelist;;
	    *)	
		# the rest goes into the openssl-doc package.
		echo %doc %{_mandir}/${i}ssl1.gz >> $OLDPWD/filelist.doc;;
	esac
done
popd
#
# check wether some shared library has been installed
#
ls -l $RPM_BUILD_ROOT%{_libdir}
test -f $RPM_BUILD_ROOT%{_libdir}/libssl.so.%{num_version}
test -f $RPM_BUILD_ROOT%{_libdir}/libcrypto.so.%{num_version}
test -L $RPM_BUILD_ROOT%{_libdir}/libssl.so
test -L $RPM_BUILD_ROOT%{_libdir}/libcrypto.so
#
# see what we've got
#
cat > showciphers.c <<EOF
#include <openssl/err.h>
#include <openssl/ssl.h>
int main(){
unsigned int i;
SSL_CTX *ctx;
SSL *ssl;
SSL_METHOD *meth;
  meth = SSLv23_client_method();
  SSLeay_add_ssl_algorithms();
  ctx = SSL_CTX_new(meth);
  if (ctx == NULL) return 0;
  ssl = SSL_new(ctx);
  if (!ssl) return 0;
  for (i=0; ; i++) {
    int j, k;
    SSL_CIPHER *sc;
    sc = (meth->get_cipher)(i);
    if (!sc) break;
    k = SSL_CIPHER_get_bits(sc, &j);
    printf("%s\n", sc->name);
  }
  return 0;
};
EOF
gcc $RPM_OPT_FLAGS -I${RPM_BUILD_ROOT}%{_includedir} -c showciphers.c
gcc -o showciphers showciphers.o -L${RPM_BUILD_ROOT}%{_libdir} -lssl -lcrypto
LD_LIBRARY_PATH=${RPM_BUILD_ROOT}%{_libdir} ./showciphers > AVAILABLE_CIPHERS || true
cat AVAILABLE_CIPHERS
# Do not install demo scripts executable under /usr/share/doc
find demos -type f -perm /111 -exec chmod 644 {} \;

#process openssllib
#mkdir $RPM_BUILD_ROOT/%{_lib}
#mv $RPM_BUILD_ROOT%{_libdir}/libssl.so.%{num_version} $RPM_BUILD_ROOT/%{_lib}/
#mv $RPM_BUILD_ROOT%{_libdir}/libcrypto.so.%{num_version} $RPM_BUILD_ROOT/%{_lib}/
rm -rf $RPM_BUILD_ROOT/usr/share/ssl
rm -rf $RPM_BUILD_ROOT/etc/ssl/openssl.cnf

# engines/ directory is hardcoded in engines/Makefile regardless of ENGINEDIR
# value in Configure, so just move the directory.
mv $RPM_BUILD_ROOT%{_libdir}/engines{,1}

ls %{buildroot}/%{_libdir}/engines1/
for engine in atalla nuron sureware ubsec cswift chil aep; do
rm %{buildroot}/%{_libdir}/engines1/lib$engine.so
done

%ifnarch %{ix86} x86_64
rm %{buildroot}/%{_libdir}/engines1/libpadlock.so
%endif

# openssl1 stuff
mv %{buildroot}/usr/bin/openssl{,1}
mv %{buildroot}/usr/bin/c_rehash{,1}

%clean
if ! test -f /.buildenv; then rm -rf $RPM_BUILD_ROOT; fi

%post -n libopenssl1_0_0
/sbin/ldconfig
env OPENSSL=openssl1 c_rehash1 %{ssletcdir}/certs > /dev/null || true

%postun -n libopenssl1_0_0 -p /sbin/ldconfig

%files -n libopenssl1_0_0
%defattr(-, root, root)
/%{_libdir}/libssl.so.%{num_version}
/%{_libdir}/libcrypto.so.%{num_version}
/%{_libdir}/engines1

%files -n libopenssl1-devel
%defattr(-, root, root)
%{_includedir}/openssl/
%{_includedir}/ssl
%{_libdir}/libcrypto.a
%{_libdir}/libssl.a
%{_libdir}/libssl.so
%{_libdir}/libcrypto.so
%_libdir/pkgconfig/libcrypto.pc
%_libdir/pkgconfig/libssl.pc
%_libdir/pkgconfig/openssl.pc

%files doc -f filelist.doc
%defattr(-, root, root)
%doc doc/* demos
%doc showciphers.c 

%files -f filelist
%defattr(-, root, root)
%doc CHANGE* INSTAL* AVAILABLE_CIPHERS
%doc LICENSE NEWS README README.SUSE
#dir %{ssletcdir}
#dir %{ssletcdir}/certs
#config (noreplace) %{ssletcdir}/openssl.cnf
#attr(700,root,root) %{ssletcdir}/private
#dir %{_datadir}/ssl
#{_datadir}/ssl/misc
%{_bindir}/c_rehash1
%{_bindir}/%{name}

%changelog
* Wed Mar  3 2021 Pedro Monreal <pmonreal@suse.com>
- Security fixes:
  * Integer overflow in CipherUpdate: Incorrect SSLv2 rollback
    protection [bsc#1182333, CVE-2021-23840]
  * Null pointer deref in X509_issuer_and_serial_hash()
    [bsc#1182331, CVE-2021-23841]
- Add openssl-CVE-2021-23840.patch openssl-CVE-2021-23841.patch
* Tue Dec  8 2020 Vítězslav Čížek <vcizek@suse.com>
- OpenSSL Security Advisory [08 December 2020]
  * Fix EDIPARTYNAME NULL pointer dereference
    (CVE-2020-1971, bsc#1179491)
  * add openssl-CVE-2020-1971.patch
* Thu Sep 10 2020 Vítězslav Čížek <vcizek@suse.com>
- OpenSSL Security Advisory [09 September 2020]
  * hardening against the Raccoon Attack (CVE-2020-1968, bsc#1176331)
  * always generate fresh DH keys, never reuse them across multiple
    TLS connections
  * SSL_OP_SINGLE_DH_USE is always set
- add openssl-CVE-2020-1968-raccoon.patch
* Mon Jan 13 2020 Pedro Monreal Gonzalez <pmonrealgonzalez@suse.com>
- Add missing commits [bsc#1117951]
  * Add openssl-add-missing-commits-for-bsc1117951.patch
* Mon Jan 13 2020 Pedro Monreal Gonzalez <pmonrealgonzalez@suse.com>
- Fix BN_copy() [bsc#1160163]
  * Add openssl-add-BN_FLG_FIXED_TOP-flag.patch
* Thu Sep 12 2019 Pedro Monreal Gonzalez <pmonrealgonzalez@suse.com>
- OpenSSL Security Advisory [10 September 2019]
  * EC_GROUP_set_generator side channel attack avoidance. [bsc#1150003, CVE-2019-1547]
  * Bleichenbacher attack against cms/pkcs7 encryption transported key [bsc#1150250, CVE-2019-1563]
- Added patches:
  * openssl-CVE-2019-1547.patch
  * openssl-CVE-2019-1563.patch
* Tue Apr 16 2019 Pedro Monreal Gonzalez <pmonrealgonzalez@suse.com>
- Fix 0-byte record padding oracle via SSL_shutdown
  (bsc#1127080, CVE-2019-1559)
  * add openssl-CVE-2019-1559.patch
* Wed Apr 10 2019 Vítězslav Čížek <vcizek@suse.com>
- Reject invalid EC point coordinates (bsc#1131291)
  * add 0001-RT-4242-reject-invalid-EC-point-coordinates.patch
* Tue Mar  5 2019 Pedro Monreal Gonzalez <pmonrealgonzalez@suse.com>
- The 9 Lives of Bleichenbacher's CAT: Cache ATtacks on TLS
  Implementations (bsc#1117951)
  * https://github.com/openssl/openssl/issues/7739
- add patches
  * openssl-Extended-OAEP-support.patch
  * openssl-rewrite-RSA-padding-checks.patch
  * openssl-add-computationally-constant-time-bn_bn2binpad.patch
  * openssl-address-Coverity-nit-in-bn2binpad.patch
  * openssl-switch-to-BN_bn2binpad.patch
  * 0001-crypto-bn-add-more-fixed-top-routines.patch
  * 0002-rsa-rsa_eay.c-implement-variant-of-Smooth-CRT-RSA.patch
  * 0003-bn-bn_blind.c-use-Montgomery-multiplication-when-pos.patch
  * 0004-bn-bn_lib.c-conceal-even-memmory-access-pattern-in-b.patch
  * 0005-err-err.c-add-err_clear_last_constant_time.patch
  * 0006-rsa-rsa_eay.c-make-RSAerr-call-in-rsa_ossl_private_d.patch
  * 0007-rsa-rsa_pk1.c-remove-memcpy-calls-from-RSA_padding_c.patch
  * 0008-rsa-rsa_oaep.c-remove-memcpy-calls-from-RSA_padding_.patch
  * 0009-rsa-rsa_ssl.c-make-RSA_padding_check_SSLv23-constant.patch
- Added required patches with backported functions bn_mul_mont_fixed_top
  and bn_mod_add_fixed_top:
  * openssl-bn_mul_mont_fixed_top.patch
  * openssl-bn_mod_add_fixed_top.patch
* Wed Nov 14 2018 Vítězslav Čížek <vcizek@suse.com>
- Elliptic curve scalar multiplication timing attack defenses
  * fixes "PortSmash" (bsc#1113534, CVE-2018-5407)
- Add openssl-CVE-2018-5407-PortSmash.patch
* Wed Nov  7 2018 Vítězslav Čížek <vcizek@suse.com>
- Add missing error string to CVE-2016-8610 fix (bsc#1110018#c9)
  * modify openssl-CVE-2016-8610.patch
* Mon Nov  5 2018 Vítězslav Čížek <vcizek@suse.com>
- OpenSSL Security Advisory [30 October 2018]
  * Timing vulnerability in DSA signature generation
    (bsc#1113652, CVE-2018-0734)
  * And more timing fixes
- Add patches:
  * openssl-CVE-2018-0734.patch
  * 0001-Merge-to-1.0.2-DSA-mod-inverse-fix.patch
  * 0001-Add-a-constant-time-flag-to-one-of-the-bignums-to-av.patch
  * 0001-DSA-Address-a-timing-side-channel-whereby-it-is-possible.patch
  * 0002-ECDSA-Address-a-timing-side-channel-whereby-it-is-possible.patch
* Thu Aug 16 2018 vcizek@suse.com
- Fix One&Done side-channel attack on RSA (bsc#1104789)
  * add openssl-One_and_Done.patch
* Thu Aug  9 2018 vcizek@suse.com
- OpenSSL Security Advisory [16 Apr 2018]
  * Cache timing vulnerability in RSA Key Generation (CVE-2018-0737)
    (bsc#1089039)
  - add openssl-CVE-2018-0737.patch
* Tue Jun 26 2018 sflees@suse.de
- Reject excessively large primes in DH key generation (bsc#1097158,
  CVE-2018-0732)
  * openssl-CVE-2018-0732.patch
- blinding enhancements for ECDSA and DSA (bsc#1097624, bsc#1098592)
  * openssl-add-blinding-to-ecdsa.patch
  * openssl-add-blinding-to-dsa.patch
* Tue Mar 27 2018 vcizek@suse.com
- OpenSSL Security Advisory [27 Mar 2018]
  * Constructed ASN.1 types with a recursive definition could exceed
    the stack (CVE-2018-0739) (bsc#1087102)
- add openssl-CVE-2018-0739.patch
* Tue Mar  6 2018 vcizek@suse.com
- Provide a DEFAULT_SUSE cipher list capability which packages can
  require (bsc#1081056, bsc#1083463)
* Fri Nov  3 2017 daniel.molkentin@suse.com
- Backport alternative chain lookup patches (bsc#1032261)
  * openssl-1.0.1i-trusted-first.patch
  * openssl-1.0.1i-alt-chains.patch
* Fri Nov  3 2017 vcizek@suse.com
- backport support for fixed DH ciphers (bsc#990592)
  * added patches:
    0001-Backport-support-for-fixed-DH-ciphersuites-from-HEAD.patch
    0001-Don-t-send-a-for-ServerKeyExchange-for-kDHr-and-kDHd.patch
    openssl-DH_fix_logjam.patch
* Fri Oct  6 2017 vcizek@suse.com
- libopenssl1_0_0: Require openssl1, so c_rehash1 is available
  during %%post to hash the certificates (bsc#1057660)
* Thu Oct  5 2017 vcizek@suse.com
- OpenSSL Security Advisory [28 Aug 2017]
  * CVE-2017-3735 (bsc#1056058)
  - Malformed X.509 IPAdressFamily could cause OOB read()
  * add openssl-CVE-2017-3735.patch
- fix crash in DES (bsc#1065363)
  * add openssl-fix_crash_in_DES.patch
* Thu Aug 31 2017 vcizek@suse.com
- Add ECDSA ciphers to DEFAULT_SUSE cipher list (bsc#1055825)
- remove DES-CBC3-SHA based ciphers from DEFAULT_SUSE (bsc#1027908)
  * added patches:
    openssl-1.0.1e-add-suse-default-cipher-header.patch
    openssl-1.0.1e-add-test-suse-default-cipher-suite.patch
    openssl-1.0.1e-add-suse-default-cipher.patch
* Tue Jan 31 2017 vcizek@suse.com
- OpenSSL Security Advisory [26 Jan 2017] (bsc#1021641)
- ECSDA P-256 timing attack key recovery (bsc#1019334, CVE-2016-7056)
- remote denial of service in SSL alert handling
  (bsc#1005878, CVE-2016-8610)
- Truncated packet could crash via OOB read (bsc#1022085, CVE-2017-3731)
- degrade 3DES to MEDIUM in SSL2 (bsc#1001912)
- fix crash in openssl speed (bsc#1000677)
- added patches:
  * openssl-CVE-2016-7056.patch
  * openssl-CVE-2016-8610.patch
  * openssl-CVE-2017-3731.patch
  * openssl-fix_crash_in_openssl_speed.patch
  * openssl-degrade_3DES_to_MEDIUM_in_SSL2.patch
- add missing commit for CVE-2016-2108 (bsc#1004499)
  * updated openssl-CVE-2016-2108.patch
- call c_rehash in %%post (bsc#1001707)
- ship static libraries in the devel package (bsc#1022644)
* Fri Sep 23 2016 vcizek@suse.com
- resume reading from /dev/urandom when interrupted by a signal
  (bsc#995075)
  * add openssl-randfile_fread_interrupt.patch
* Thu Sep 22 2016 vcizek@suse.com
- OpenSSL Security Advisory [22 Sep 2016] (bsc#999665)
  Severity: High
  * OCSP Status Request extension unbounded memory growth
    (CVE-2016-6304) (bsc#999666)
  Severity: Low
  * Pointer arithmetic undefined behaviour (CVE-2016-2177) (bsc#982575)
  * Constant time flag not preserved in DSA signing (CVE-2016-2178) (bsc#983249)
  * DTLS buffered message DoS (CVE-2016-2179) (bsc#994844)
  * OOB read in TS_OBJ_print_bio() (CVE-2016-2180) (bsc#990419)
  * DTLS replay protection DoS (CVE-2016-2181) (bsc#994749)
  * OOB write in BN_bn2dec() (CVE-2016-2182) (bsc#993819)
  * Birthday attack against 64-bit block ciphers (SWEET32)
    (CVE-2016-2183) (bsc#995359)
  * Malformed SHA512 ticket DoS (CVE-2016-6302) (bsc#995324)
  * OOB write in MDC2_Update() (CVE-2016-6303) (bsc#995377)
  * Certificate message OOB reads (CVE-2016-6306) (bsc#999668)
- added patches:
  * openssl-CVE-2016-2177.patch
  * openssl-CVE-2016-2178.patch
  * openssl-CVE-2016-2179.patch
  * openssl-CVE-2016-2180.patch
  * openssl-CVE-2016-2181.patch
  * openssl-CVE-2016-2182.patch
  * openssl-CVE-2016-2183.patch
  * openssl-CVE-2016-6302.patch
  * openssl-CVE-2016-6303.patch
  * openssl-CVE-2016-6304.patch
  * openssl-CVE-2016-6306.patch
* Wed Aug  3 2016 vcizek@suse.com
- update expired S/MIME certs (bsc#979475)
  * add openssl-update-expired-smime-certs.patch
- improve s390x performance (bsc#982745)
  * add openssl-s390x_performance_improvements.patch
- fix crash in print_notice (bsc#998190)
  * add openssl-print_notice-NULL_crash.patch
* Fri Apr 29 2016 vcizek@suse.com
- libopenssl1_0_0 now Recommends: openssl1 to get correct SSL Root
  Certificate hashes (bsc#971354)
- Rename README.SuSE to the new spelling (bsc#889013)
* Thu Apr 28 2016 vcizek@suse.com
- OpenSSL Security Advisory [3rd May 2016]
  * Memory corruption in the ASN.1 encoder
  - bsc#977617 (CVE-2016-2108)
  * Padding oracle in AES-NI CBC MAC check
  - bsc#977616 (CVE-2016-2107)
  * EVP_EncodeUpdate overflow
  - bsc#977614 (CVE-2016-2105)
  * EVP_EncryptUpdate overflow
  - bsc#977615 (CVE-2016-2106)
  * ASN.1 BIO excessive memory allocation
  - bsc#976942 (CVE-2016-2109)
  * add patches
    + openssl-CVE-2016-2105.patch
    + openssl-CVE-2016-2106.patch
    + openssl-CVE-2016-2107.patch
    + openssl-CVE-2016-2108.patch
    + openssl-CVE-2016-2109.patch
- Fix buffer overrun in ASN1_parse (bsc#976943)
  * add 0001-Fix-buffer-overrun-in-ASN1_parse.patch
- Preserve digests for SNI (bsc#977621)
  * add 0001-Preserve-digests-for-SNI.patch
* Fri Feb 26 2016 psimons@suse.com
- Fix CVE-2016-0702 (bnc#968050, "Cache Bleed"). The patch
  "openssl-CVE-2016-0702-openssl101.patch" prevents side channel
  attacks on modular exponentiation that attempted to recover RSA
  secret keys by analyzing cache-bank conflicts on the Intel
  Sandy-Bridge microarchitecture. The ability to exploit this issue
  was limited, however, as it required the attacker to have control
  of code running in a thread on the same hyper-threaded core as the
  victim thread which was performing decryptions.
- Fix CVE-2016-0705 (bnc#968047) via "openssl-CVE-2016-0705.patch".
  This issue allowed attackers with the ability to load malformed
  DSA private keys into applications based on OpenSSL to trigger a
  double free() bug in OpenSSL's parser code. That scenario could be
  abused to facilitate a denial-of-service attack.
- Fix CVE-2016-0797 (bnc#968048) via "openssl-CVE-2016-0797.patch".
  The BN_hex2bn() and BN_dec2bn() functions had a bug that could
  result in an attempt to de-reference a NULL pointer. This could
  have security consequences if these functions were ever called by
  user applications with large untrusted hex/decimal data. Also,
  internal usage of these functions in OpenSSL uses data from config
  files or application command line arguments. If user developed
  applications generated config file data based on untrusted data,
  then this could have had security consequences as well.
- Fix CVE-2016-0800 (bnc#968046, "Drown"). OpenSSL used to be
  vulnerable to a cross-protocol attack that could lead to
  decryption of TLS sessions by using a server supporting SSLv2 and
  EXPORT cipher suites as a Bleichenbacher RSA padding oracle. The
  patch "openssl-CVE-2016-0800-DROWN-disable-ssl2.patch" remedies
  this issue by disabling the SSLv2 protocol (unless the environment
  variable $OPENSSL_ALLOW_SSL2 is defined) and all weak EXPORT
  ciphers (unless $OPENSSL_ALLOW_EXPORT is defined).
- Fix CVE-2016-0798 via "openssl-CVE-2016-0798-101.patch". The SRP
  user database lookup method SRP_VBASE_get_by_user() had a memory
  leak that attackers could abuse to facility DoS attacks. To
  mitigate the issue, the seed handling in SRP_VBASE_get_by_user()
  was disabled even if the user has configured a seed. Applications
  are advised to migrate to SRP_VBASE_get1_by_user(). (bnc#968265)
- Fix CVE-2016-0799 (bnc#968374) via "openssl-CVE-2016-0799.patch".
  On many 64 bit systems, the internal fmtstr() and doapr_outch()
  functions could miscalculate the length of a string and attempt to
  access out-of-bounds memory locations. These problems could have
  enabled attacks where large amounts of untrusted data is passed to
  the BIO_*printf functions. If applications use these functions in
  this way then they could have been vulnerable. OpenSSL itself uses
  these functions when printing out human-readable dumps of ASN.1
  data. Therefore applications that print this data could have been
  vulnerable if the data is from untrusted sources. OpenSSL command
  line applications could also have been vulnerable when they print
  out ASN.1 data, or if untrusted data is passed as command line
  arguments. Libssl is not considered directly vulnerable.
* Fri Feb 12 2016 vcizek@suse.com
- avoid running OPENSSL_config twice. This avoids breaking
  engine loading. (bsc#952871)
  * add openssl-avoid-config-twice.patch
- openssl.keyring: replaced with correct release engineer key
* Fri Feb 12 2016 vcizek@suse.com
- fix CVE-2015-3197 (bsc#963415)
  * SSLv2 doesn't block disabled ciphers
  * add openssl-CVE-2015-3197.patch
* Thu Dec  3 2015 vcizek@suse.com
- security fixes:
  * Certificate verify crash with missing PSS parameter
    (CVE-2015-3194) (bsc#957815)
  * X509_ATTRIBUTE memory leak (CVE-2015-3195) (bsc#957812)
  * Race condition handling PSK identify hint (CVE-2015-3196)
    (bsc#957813)
  * added patches:
    openssl-CVE-2015-3194.patch
    openssl-CVE-2015-3195.patch
    openssl-CVE-2015-3196.patch
* Mon Nov  9 2015 vcizek@suse.com
- improve s390 performance (bsc#954256)
  * added 0001-bn-asm-s390x.S-improve-performance-on-z196-and-z13-b.patch
* Thu Aug 13 2015 vcizek@suse.com
- add support for "ciphers" providing no encryption (bsc#937085)
  * don't build with -DSSL_FORBID_ENULL
* Tue Aug  4 2015 vcizek@suse.com
- fixed a regression caused by openssl-CVE-2015-0287.patch
  (bsc#937492)
* Fri Jun 12 2015 vcizek@suse.com
- CVE-2015-4000 (boo#931698)
  * The Logjam Attack / weakdh.org
  * reject connections with DH parameters shorter than 1024 bits
  * generates 2048-bit DH parameters by default
- CVE-2015-1788 (boo#934487)
  * Malformed ECParameters causes infinite loop
- CVE-2015-1789 (boo#934489)
  * Exploitable out-of-bounds read in X509_cmp_time
- CVE-2015-1790 (boo#934491)
  * PKCS7 crash with missing EnvelopedContent
- CVE-2015-1792 (boo#934493)
  * CMS verify infinite loop with unknown hash function
- CVE-2015-1791 (boo#933911)
  * race condition in NewSessionTicket
- CVE-2014-8176 (boo#934494)
  * invalid free in DTLS
- fix timing side channel in RSA decryption (bnc#929678)
- newly added patches:
  * 0001-s_server-Use-2048-bit-DH-parameters-by-default.patch
  * 0002-dhparam-set-the-default-to-2048-bits.patch
  * 0003-dhparam-fix-documentation.patch
  * 0004-Update-documentation-with-Diffie-Hellman-best-practi.patch
  * 0005-client-reject-handshakes-with-DH-parameters-1024-bits.patch
  * openssl-CVE-2014-8176.patch
  * openssl-CVE-2015-1788.patch
  * openssl-CVE-2015-1789.patch
  * openssl-CVE-2015-1790.patch
  * openssl-CVE-2015-1791.patch
  * openssl-CVE-2015-1792.patch
  * openssl-RSA_premaster_secret_in_constant_time.patch
* Thu Apr 16 2015 vcizek@suse.com
- Add option to disable padding extension (bnc#923384)
  * added openssl-add_option_to_disable_padding_extension.patch
* Mon Mar 16 2015 vcizek@suse.com
- security update:
  * CVE-2015-0209 (bnc#919648)
  - Fix a failure to NULL a pointer freed on error
  * CVE-2015-0286 (bnc#922496)
  - Segmentation fault in ASN1_TYPE_cmp
  * CVE-2015-0287 (bnc#922499)
  - ASN.1 structure reuse memory corruption
  * CVE-2015-0288 x509: (bnc#920236)
  - added missing public key is not NULL check
  * CVE-2015-0289 (bnc#922500)
  - PKCS7 NULL pointer dereferences
  * CVE-2015-0292 (bnc#922501)
  - Base64 decode
  * CVE-2015-0293 (bnc#922488)
  - Fix reachable assert in SSLv2 servers
  * added patches:
  openssl-CVE-2015-0209.patch
  openssl-CVE-2015-0286.patch
  openssl-CVE-2015-0287.patch
  openssl-CVE-2015-0288.patch
  openssl-CVE-2015-0289.patch
  openssl-CVE-2015-0292.patch
  openssl-CVE-2015-0293.patch
* Thu Jan  8 2015 vcizek@suse.com
- fix for several security vulnerabilites:
  * CVE-2014-3570 (bnc#912296)
  - Bignum squaring (BN_sqr) may produce incorrect results on some
    platforms, including x86_64.
  - added openssl-CVE-2014-3570.patch
  * CVE-2014-3571 (bnc#912294)
  - Fix crash in dtls1_get_record whilst in the listen state where
    you get two separate reads performed - one for the header and
    one for the body of the handshake record.
  - added openssl-CVE-2014-3571.patch
  * CVE-2014-3572 (bnc#912015)
  - don't accept a handshake using an ephemeral ECDH ciphersuites
    with the server key exchange message omitted.
  - added openssl-CVE-2014-3572.patch
  * CVE-2014-8275 (bnc#912018)
  - fix various certificate fingerprint issues
  - added openssl-CVE-2014-8275.patch
  * CVE-2015-0204 (bnc#912014)
  - Only allow ephemeral RSA keys in export ciphersuites
  - added openssl-CVE-2015-0204.patch
  * CVE-2015-0205 (bnc#912293)
  - Fix to prevent use of DH client certificates without sending
    certificate verify message.
  - added openssl-CVE-2015-0205.patch
  * CVE-2015-0206 (bnc#912292)
  - memory leak can occur in dtls1_buffer_record
  - added openssl-CVE-2015-0206.patch
* Tue Nov 25 2014 vcizek@suse.com
- don't advertise curves we don't support (bnc#906878)
  * added openssl-Added-OPENSSL_NO_EC2M-guards-around-the-preferred-EC.patch
* Tue Oct 21 2014 vcizek@suse.com
- security fixes for bnc#901277 and bnc#901223
- NOTE: this update alone DOESN'T FIX the POODLE SSL protocol vulnerability.
  OpenSSL only adds downgrade detection support for client applications.
  See https://www.suse.com/support/kb/doc.php?id=7015773 for mitigations.
- details of the addressed vulnerabilities:
  * ) SRTP Memory Leak.
    A flaw in the DTLS SRTP extension parsing code allows an attacker, who
    sends a carefully crafted handshake message, to cause OpenSSL to fail
    to free up to 64k of memory causing a memory leak. This could be
    exploited in a Denial Of Service attack. This issue affects OpenSSL
    1.0.1 server implementations for both SSL/TLS and DTLS regardless of
    whether SRTP is used or configured. Implementations of OpenSSL that
    have been compiled with OPENSSL_NO_SRTP defined are not affected.
    (CVE-2014-3513)
  * ) Session Ticket Memory Leak.
    When an OpenSSL SSL/TLS/DTLS server receives a session ticket the
    integrity of that ticket is first verified. In the event of a session
    ticket integrity check failing, OpenSSL will fail to free memory
    causing a memory leak. By sending a large number of invalid session
    tickets an attacker could exploit this issue in a Denial Of Service
    attack.
    (CVE-2014-3567)
  * ) Build option no-ssl3 is incomplete.
    When OpenSSL is configured with "no-ssl3" as a build option, servers
    could accept and complete a SSL 3.0 handshake, and clients could be
    configured to send them.
    (CVE-2014-3568)
  * ) Add support for TLS_FALLBACK_SCSV.
    Client applications doing fallback retries should call
    SSL_set_mode(s, SSL_MODE_SEND_FALLBACK_SCSV).
    (CVE-2014-3566)
* Tue Aug 12 2014 meissner@suse.com
- README.SuSE: document how to build against / with openssl 1.0.1
  bnc#889812
* Mon Aug 11 2014 vcizek@suse.com
- Double Free when processing DTLS packets (CVE-2014-3505)
  * added openssl-CVE-2014-3505.patch
  * bnc#890767
- DTLS memory exhaustion (CVE-2014-3506)
  * added openssl-CVE-2014-3506.patch
  * bnc#890768
- DTLS memory leak from zero-length fragments (CVE-2014-3507)
  * added openssl-CVE-2014-3507.patch
  * bnc#890769
- Information leak in pretty printing functions (CVE-2014-3508)
  * added openssl-CVE-2014-3508.patch
  * bnc#890764
- Race condition in ssl_parse_serverhello_tlsext (CVE-2014-3509)
  * added openssl-CVE-2014-3509.patch
  * bnc#890766
- OpenSSL DTLS anonymous EC(DH) denial of service (CVE-2014-3510)
  * added openssl-CVE-2014-3510.patch
  * bnc#890770
- TLS protocol downgrade attack (CVE-2014-3511)
  * added openssl-CVE-2014-3511.patch
  * bnc#890771
- SRP buffer overrun (CVE-2014-3512)
  * added openssl-CVE-2014-3512.patch
  * bnc#890772
- Crash with SRP ciphersuite in Server Hello message (CVE-2014-5139)
  * added openssl-CVE-2014-5139.patch
  * bnc#890765
* Mon Jun  2 2014 shchang@suse.com
- Fixed bug[ bnc#880891], multiple OpenSSL CVE issues
  Add patch files: CVE-2014-3470.patch, CVE-2014-0221.patch, CVE-2014-0224.patch, CVE-2014-0195.patch
* Mon May  5 2014 shchang@suse.com
- Fixed bug[ bnc#876282], CVE-2014-0198 openssl: OpenSSL NULL pointer dereference in do_ssl3_write
  Add file: CVE-2014-0198.patch
* Tue Apr 15 2014 meissner@suse.com
- use the old SLE11 trust store location, /etc/ssl/certs
* Sat Apr 12 2014 shchang@suse.com
- Fixed bug[ bnc#873351] CVE-2010-5298: openssl: Use-after-free race condition,in OpenSSL's read buffer
  Add file: CVE-2010-5298.patch
* Fri Apr 11 2014 meissner@suse.com
- updated to 1.0.1g stable version.
  Includes fixes for:
  - CVE-2014-0160: remote memory disclosure aka "The HeartBleed attack".
  - CVE-2014-0076: Recovering OpenSSL ECDSA Nonces Using the FLUSH+RELOAD
    Cache Side-channel Attack
- openssl1.keyring: tarballs now signed by Dr. Stephen Henssons 4096bit key.
* Mon Apr  7 2014 meissner@suse.com
- openssl-CVE-2014-0160-TLS-heartbeat-read-overrun.patch:
  Fixed a remote memory disclosure via missing boundary checks in
  TLS heartbeat, bnc#872299 / CVE-2014-0160
* Tue Jan 28 2014 meissner@suse.com
- Adapted the SLE12 openssl 1.0.1f for usage in SLE11.
  (FATE#316898 / bnc#861014 / bnc#864912)
  - FIPS work is disabled for now as its not yet finished
  - engines moved to /engines1/ directory to avoid conflicts.
- libopenssl1_0_0 shared library package, with engines
  in /engines1/ directory.
- libopenssl1-devel package (conflicting with libopenssl-devel)
- openssl1 package that can coexist alongside openssl
  package with "openssl1" commandline tool.
  - Use c_rehash1 for generating openssl1 and openssl0 compatible hashes.
- bug-860332-cmdline-check-certs.patch: check /etc/ssl/certs
  by default in the commandline tool. (bnc#860332)
- Fix bug[ bnc#869945] CVE-2014-0076: openssl: Recovering OpenSSL ECDSA
  Nonces Using the FLUSH+RELOAD Cache Side-channel Attack
  Add file: CVE-2014-0076.patch
* Thu Jan  9 2014 andreas.stieger@gmx.de
- 1.0.1f:
  * Fix for TLS record tampering bug CVE-2013-4353
- already included:
  * Fix for TLS version checking bug CVE-2013-6449
  * Fix for DTLS retransmission bug CVE-2013-6450
- removed patches:
  * CVE-2013-6449.patch, committed upstream
  * CVE-2013-6450.patch, committed upstream
  * SSL_get_certificate-broken.patch, committed upstream
  * openssl-1.0.1e-bnc822642.patch, committed upstream
- modified patches:
  * openssl-1.0.1e-fips.patch, adjust for upstream changes
  * openssl-fix-pod-syntax.diff, adjust for upstream changes
* Wed Jan  8 2014 andreas.stieger@gmx.de
- add a gpg keyring for source tarball
* Wed Jan  8 2014 shchang@suse.com
- Fixed bnc#857850, openssl doesn't load engine
  Modify file: openssl.spec
* Thu Jan  2 2014 shchang@suse.com
- Fixed bnc#857203, openssl: crash in DTLS renegotiation after packet loss
  Add file: CVE-2013-6450.patch
* Sun Dec 22 2013 shchang@suse.com
- Fixed bnc#856687, openssl: crash when using TLS 1.2
  Add file: CVE-2013-6449.patch
* Tue Dec 17 2013 meissner@suse.com
- compression_methods_switch.patch: setenv might not be successful
  if a surrounding library or application filters it, like e.g. sudo.
  As setenv() does not seem to be useful anyway, remove it.
  bnc#849377
* Mon Dec 16 2013 shchang@suse.com
- Adjust the installation path.
  Modify files: README-FIPS.txt openssl.spec
* Fri Dec  6 2013 lnussel@suse.de
- don't own /etc/ssl/certs, it's owned by ca-certificates
* Tue Dec  3 2013 meissner@suse.com
- Actually enable it (in a building way) for openSUSE and SLES,
  as we intended.
- Add README-FIPS.txt from SLE 11.
* Mon Dec  2 2013 crrodriguez@opensuse.org
- Restrict the (broken beyond build) FIPS certification code
  to SLE releases only, it has no value in openSUSE at all.
* Sat Nov 23 2013 shchang@suse.com
- Patches for OpenSSL FIPS-140-2/3 certification
  Add patch files: openssl-1.0.1e-fips.patch, openssl-1.0.1e-fips-ec.patch,
  openssl-1.0.1e-fips-ctor.patch
* Wed Oct 23 2013 crrodriguez@opensuse.org
- 0001-libcrypto-Hide-library-private-symbols.patch
  This patch implements the libcrpto part complimentary to
  0005-libssl-Hide-library-private-symbols.patch.
  This patch is however not 100%% complete, as some private library
  symbols are declared in public headers that shall not be touched
  or are defined/declared in "perlasm". (tested in 13.1, 12.3, factory)
- openSSL defaults to -O3 optimization level but we override
  it with RPM_OPT_FLAGS, ensure we use -O3 like upstream.
* Fri Oct 11 2013 meissner@suse.com
- openssl-1.0.1c-ipv6-apps.patch:
  Support ipv6 in the openssl s_client / s_server commandline app.
* Fri Sep 27 2013 dmacvicar@suse.de
- VPN openconnect problem (DTLS handshake failed)
  (git 9fe4603b8, bnc#822642, openssl ticket#2984)
* Wed Sep  4 2013 guillaume@opensuse.org
- Fix armv6l arch (armv7 was previously used to build armv6 which
  lead to illegal instruction when used)
* Mon Aug 12 2013 shchang@suse.com
- Fix bug[ bnc#832833] openssl ssl_set_cert_masks() is broken
  modify patch file: SSL_get_certificate-broken.patch
* Fri Aug  9 2013 crrodriguez@opensuse.org
- Via padlock is only found in x86 and x86_64 CPUs, remove
  the shared module for other archs.
* Wed Aug  7 2013 crrodriguez@opensuse.org
- Cleanup engines that are of no use in a modern linux distro
- The following engines stay:
  * libcapi.so --> usable in case you have third party /dev/crypto
  * libgmp.so --> may help to doing some maths using GMP
  * libgost.so --> implements the GOST block cipher
  * libpadlock.so --> VIA padlock support
- Al other are removed because they require third party propietary
  shared libraries nowhere to be found or that we can test.
* Wed Aug  7 2013 crrodriguez@opensuse.org
- openssl-pkgconfig.patch: Here we go.. For applications
  to benefit fully of features provided by openSSL engines
  (rdrand, aes-ni..etc) either builtin or in DSO form applications
  have to call ENGINE_load_builtin_engines() or OPENSSL_config()
  unfortunately from a total of 68 apps/libraries linked to libcrypto
  in a desktop system, only 4 do so, and there is a sea of buggy
  code that I dont feel like fixing.
  Instead we can pass -DOPENSSL_LOAD_CONF in the pkgconfig files
  so the needed operation becomes implicit the next time such apps
  are recompiled, see OPENSSL_config(3)
  Unfortunately this does not fix everything, because there are apps
  not using pkgconfig or using it incorrectly, but it is a good start.
* Wed Aug  7 2013 dmueller@suse.com
- add openssl-1.0.1c-default-paths.patch:
  Fix from Fedora for openssl s_client not setting
  CApath by default
* Sat Aug  3 2013 crrodriguez@opensuse.org
- 0005-libssl-Hide-library-private-symbols.patch: hide
  private symbols, this *only* applies to libssl where
  it is straightforward to do so as applications should
  not be using any of the symbols declared/defined in headers
  that the library does not install.
  A separate patch MAY be provided in the future for libcrypto
  where things are much more complicated and threfore requires
  careful testing.
* Mon Jul 29 2013 meissner@suse.com
- compression_methods_switch.patch: Disable compression by default to
  avoid the CRIME attack (CVE-2012-4929 bnc#793420)
  Can be override by setting environment variable
    OPENSSL_NO_DEFAULT_ZLIB=no
* Tue Jul  2 2013 lnussel@suse.de
- Don't use the legacy /etc/ssl/certs directory anymore but rather
  the p11-kit generated /var/lib/ca-certificates/openssl one
  (fate#314991, openssl-1.0.1e-truststore.diff)
* Sat Jun 29 2013 crrodriguez@opensuse.org
- Build enable-ec_nistp_64_gcc_128, ecdh is many times faster
  but only works in x86_64.
  According to the openSSL team
  "it is superior to the default in multiple regards (speed, and also
  security as the new implementations are secure against timing
  attacks)"
  It is not enabled by default due to the build system being unable
  to detect if the compiler supports __uint128_t.
* Thu Jun 20 2013 coolo@suse.com
- pick openssl-fix-pod-syntax.diff out of the upstream RT to fix
  build with perl 5.18
* Sat May 25 2013 i@marguerite.su
- add %%if tag for BuildArch. sles may also need latest openssl.
* Fri Feb 22 2013 dmueller@suse.com
- disable fstack-protector on aarch64
* Tue Feb 12 2013 hrvoje.senjan@gmail.com
- Update to 1.0.1e
  o Bugfix release (bnc#803004)
- Drop openssl-1.0.1d-s3-packet.patch, included upstream
* Sun Feb 10 2013 hrvoje.senjan@gmail.com
- Added openssl-1.0.1d-s3-packet.patch from upstream, fixes
  bnc#803004, openssl ticket#2975
* Tue Feb  5 2013 meissner@suse.com
- update to version 1.0.1d, fixing security issues
  o Fix renegotiation in TLS 1.1, 1.2 by using the correct TLS version.
  o Include the fips configuration module.
  o Fix OCSP bad key DoS attack CVE-2013-0166
  o Fix for SSL/TLS/DTLS CBC plaintext recovery attack CVE-2013-0169
    bnc#802184
  o Fix for TLS AESNI record handling flaw CVE-2012-2686
* Mon Nov 12 2012 gjhe@suse.com
- fix bug[bnc#784994] - VIA padlock support on 64 systems
  e_padlock: add support for x86_64 gcc
* Sun Aug 19 2012 crrodriguez@opensuse.org
- Open Internal file descriptors with O_CLOEXEC, leaving
  those open across fork()..execve() makes a perfect
  vector for a side-channel attack...
* Tue Aug  7 2012 dmueller@suse.com
- fix build on armv5 (bnc#774710)
* Thu May 10 2012 crrodriguez@opensuse.org
- Update to version 1.0.1c for the complete list of changes see
  NEWS, this only list packaging changes.
- Drop aes-ni patch, no longer needed as it is builtin in openssl
  now.
- Define GNU_SOURCE and use -std=gnu99 to build the package.
- Use LFS_CFLAGS in platforms where it matters.
* Fri May  4 2012 lnussel@suse.de
- don't install any demo or expired certs at all
* Mon Apr 23 2012 gjhe@suse.com
- update to latest stable verison 1.0.0i
  including the following patches:
  CVE-2012-2110.path
  Bug748738_Tolerate_bad_MIME_headers.patch
  bug749213-Free-headers-after-use.patch
  bug749210-Symmetric-crypto-errors-in-PKCS7_decrypt.patch
  CVE-2012-1165.patch
  CVE-2012-0884.patch
  bug749735.patch
* Tue Mar 27 2012 gjhe@suse.com
- fix bug[bnc#749735] - Memory leak when creating public keys.
  fix bug[bnc#751977] - CMS and S/MIME Bleichenbacher attack
  CVE-2012-0884
* Thu Mar 22 2012 gjhe@suse.com
- fix bug[bnc#751946] - S/MIME verification may erroneously fail
  CVE-2012-1165
* Wed Mar 21 2012 gjhe@suse.com
- fix bug[bnc#749213]-Free headers after use in error message
  and bug[bnc#749210]-Symmetric crypto errors in PKCS7_decrypt
* Tue Mar 20 2012 cfarrell@suse.com
- license update: OpenSSL
* Fri Feb 24 2012 gjhe@suse.com
- fix bug[bnc#748738] - Tolerate bad MIME headers in openssl's
  asn1 parser.
  CVE-2006-7250
* Thu Feb  2 2012 gjhe@suse.com
- Update to version 1.0.0g fix the following:
  DTLS DoS attack (CVE-2012-0050)
* Wed Jan 11 2012 gjhe@suse.com
- Update to version 1.0.0f fix the following:
  DTLS Plaintext Recovery Attack (CVE-2011-4108)
  Uninitialized SSL 3.0 Padding (CVE-2011-4576)
  Malformed RFC 3779 Data Can Cause Assertion Failures (CVE-2011-4577)
  SGC Restart DoS Attack (CVE-2011-4619)
  Invalid GOST parameters DoS Attack (CVE-2012-0027)
* Tue Oct 18 2011 crrodriguez@opensuse.org
- AES-NI: Check the return value of Engine_add()
  if the ENGINE_add() call fails: it ends up adding a reference
  to a freed up ENGINE which is likely to subsequently contain garbage
  This will happen if an ENGINE with the same name is added multiple
  times,for example different libraries. [bnc#720601]
* Sat Oct  8 2011 crrodriguez@opensuse.org
- Build with -DSSL_FORBID_ENULL so servers are not
  able to use the NULL encryption ciphers (Those offering no
  encryption whatsoever).
* Wed Sep  7 2011 crrodriguez@opensuse.org
- Update to openssl 1.0.0e fixes CVE-2011-3207 and CVE-2011-3210
  see http://openssl.org/news/secadv_20110906.txt for details.
* Sat Aug  6 2011 crrodriguez@opensuse.org
- Add upstream patch that calls ENGINE_register_all_complete()
  in ENGINE_load_builtin_engines() saving us from adding dozens
  of calls to such function to calling applications.
* Fri Aug  5 2011 crrodriguez@opensuse.org
- remove -fno-strict-aliasing from CFLAGS no longer needed
  and is likely to slow down stuff.
* Mon Jul 25 2011 jengelh@medozas.de
- Edit baselibs.conf to provide libopenssl-devel-32bit too
* Fri Jun 24 2011 gjhe@novell.com
- update to latest stable version 1.0.0d.
  patch removed(already in the new package):
  CVE-2011-0014
  patch added:
  ECDSA_signatures_timing_attack.patch
* Tue May 31 2011 gjhe@novell.com
- fix bug[bnc#693027].
  Add protection against ECDSA timing attacks as mentioned in the paper
  by Billy Bob Brumley and Nicola Tuveri, see:
  http://eprint.iacr.org/2011/232.pdf
  [Billy Bob Brumley and Nicola Tuveri]
* Mon May 16 2011 andrea@opensuse.org
- added openssl as dependency in the devel package
* Thu Feb 10 2011 gjhe@novell.com
- fix bug [bnc#670526]
  CVE-2011-0014,OCSP stapling vulnerability
* Sat Jan 15 2011 cristian.rodriguez@opensuse.org
- Add patch from upstream in order to support AES-NI instruction
  set present on current Intel and AMD processors
* Mon Jan 10 2011 meissner@suse.de
- enable -DPURIFY to avoid valgrind errors.
* Thu Dec  9 2010 gjhe@novell.com
- update to stable version 1.0.0c.
  patch included:
  CVE-2010-1633_and_CVE-2010-0742.patch
  patchset-19727.diff
  CVE-2010-2939.patch
  CVE-2010-3864.patch
* Thu Nov 18 2010 gjhe@novell.com
- fix bug [bnc#651003]
  CVE-2010-3864
* Sat Sep 25 2010 gjhe@novell.com
- fix bug [bnc#629905]
  CVE-2010-2939
* Wed Jul 28 2010 cristian.rodriguez@opensuse.org
- Exclude static libraries, see what breaks and fix that
  instead
* Wed Jun 30 2010 jengelh@medozas.de
- fix two compile errors on SPARC
* Tue Jun 15 2010 bg@novell.com
- -fstack-protector is not supported on hppa
* Fri Jun  4 2010 gjhe@novell.com
- fix bnc #610642
  CVE-2010-0742
  CVE-2010-1633
* Mon May 31 2010 gjhe@novell.com
- fix bnc #610223,change Configure to tell openssl to load engines
  from /%%{_lib} instead of %%{_libdir}
* Mon May 10 2010 aj@suse.de
- Do not compile in build time but use mtime of changes file instead.
  This allows build-compare to identify that no changes have happened.
* Tue May  4 2010 gjhe@novell.com
- build libopenssl to /%%{_lib} dir,and keep only one
  libopenssl-devel for new developping programs.
* Tue Apr 27 2010 gjhe@novell.com
- build libopenssl and libopenssl-devel to a version directory
* Sat Apr 24 2010 coolo@novell.com
- buildrequire pkg-config to fix provides
* Wed Apr 21 2010 lnussel@suse.de
- also create old certificate hash in /etc/ssl/certs for
  compatibility with applications that still link against 0.9.8
* Mon Apr 12 2010 meissner@suse.de
- Disable our own build targets, instead use the openSSL provided ones
  as they are now good (or should be good at least).
- add -Wa,--noexecstack to the Configure call, this is the upstream
  approved way to avoid exec-stack marking
* Mon Apr 12 2010 gjhe@novell.com
- update to 1.0.0
  Merge the following patches from 0.9.8k:
  openssl-0.9.6g-alpha.diff
  openssl-0.9.7f-ppc64.diff
  openssl-0.9.8-flags-priority.dif
  openssl-0.9.8-sparc.dif
  openssl-allow-arch.diff
  openssl-hppa-config.diff
* Fri Apr  9 2010 meissner@suse.de
- fixed "exectuable stack" for libcrypto.so issue on i586 by
  adjusting the assembler output during MMX builds.
* Wed Apr  7 2010 meissner@suse.de
- Openssl is now partially converted to libdir usage upstream,
  merge that in to fix lib64 builds.
* Thu Mar 25 2010 gjhe@novell.com
- fix security bug [bnc#590833]
  CVE-2010-0740
* Mon Mar 22 2010 gjhe@novell.com
- update to version 0.9.8m
  Merge the following patches from 0.9.8k:
  bswap.diff
  non-exec-stack.diff
  openssl-0.9.6g-alpha.diff
  openssl-0.9.7f-ppc64.diff
  openssl-0.9.8-flags-priority.dif
  openssl-0.9.8-sparc.dif
  openssl-allow-arch.diff
  openssl-hppa-config.diff
* Fri Feb  5 2010 jengelh@medozas.de
- build openssl for sparc64
* Mon Dec 14 2009 jengelh@medozas.de
- add baselibs.conf as a source
- package documentation as noarch
* Tue Nov  3 2009 coolo@novell.com
- updated patches to apply with fuzz=0
* Tue Sep  1 2009 gjhe@novell.com
- fix Bug [bnc#526319]
* Wed Aug 26 2009 coolo@novell.com
- use %%patch0 for Patch0
* Fri Jul  3 2009 gjhe@novell.com
- update to version 0.9.8k
- patches merged upstream:
  openssl-CVE-2008-5077.patch
  openssl-CVE-2009-0590.patch
  openssl-CVE-2009-0591.patch
  openssl-CVE-2009-0789.patch
  openssl-CVE-2009-1377.patch
  openssl-CVE-2009-1378.patch
  openssl-CVE-2009-1379.patch
  openssl-CVE-2009-1386.patch
  openssl-CVE-2009-1387.patch
* Tue Jun 30 2009 gjhe@novell.com
- fix security bug [bnc#509031]
  CVE-2009-1386
  CVE-2009-1387
* Tue Jun 30 2009 gjhe@novell.com
- fix security bug [bnc#504687]
  CVE-2009-1377
  CVE-2009-1378
  CVE-2009-1379
* Wed Apr 15 2009 gjhe@suse.de
- fix security bug [bnc#489641]
  CVE-2009-0590
  CVE-2009-0591
  CVE-2009-0789
* Wed Jan  7 2009 olh@suse.de
- obsolete old -XXbit packages (bnc#437293)
* Thu Dec 18 2008 jshi@suse.de
- fix security bug [bnc#459468]
  CVE-2008-5077
* Tue Dec  9 2008 xwhu@suse.de
- Disable optimization for s390x
* Mon Dec  8 2008 xwhu@suse.de
- Disable optimization of md4
* Mon Nov 10 2008 xwhu@suse.de
- Disable optimization of ripemd [bnc#442740]
* Tue Oct 14 2008 xwhu@suse.de
- Passing string as struct cause openssl segment-fault [bnc#430141]
* Wed Jul 16 2008 mkoenig@suse.de
- do not require openssl-certs, but rather recommend it
  to avoid dependency cycle [bnc#408865]
* Wed Jul  9 2008 mkoenig@suse.de
- remove the certs subpackage from the openssl package
  and move the CA root certificates into a package of its own
* Tue Jun 24 2008 mkoenig@suse.de
- update to version 0.9.8h
- openssl does not ship CA root certificates anymore
  keep certificates that SuSE is already shipping
- resolves bad array index (function has been removed) [bnc#356549]
- removed patches
  openssl-0.9.8g-fix_dh_for_certain_moduli.patch
  openssl-CVE-2008-0891.patch
  openssl-CVE-2008-1672.patch
* Wed May 28 2008 mkoenig@suse.de
- fix OpenSSL Server Name extension crash (CVE-2008-0891)
  and OpenSSL Omit Server Key Exchange message crash (CVE-2008-1672)
  [bnc#394317]
* Wed May 21 2008 cthiel@suse.de
- fix baselibs.conf
* Tue Apr 22 2008 mkoenig@suse.de
- add -DMD32_REG_T=int for x86_64 and ia64 [bnc#381844]
* Thu Apr 10 2008 ro@suse.de
- added baselibs.conf file to build xxbit packages
  for multilib support
* Mon Nov  5 2007 mkoenig@suse.de
- fix Diffie-Hellman failure with certain prime lengths
* Mon Oct 22 2007 mkoenig@suse.de
- update to version 0.9.8g:
  * fix some bugs introduced with 0.9.8f
* Mon Oct 15 2007 mkoenig@suse.de
- update to version 0.9.8f:
  * fixes CVE-2007-3108, CVE-2007-5135, CVE-2007-4995
- patches merged upstream:
  openssl-0.9.8-key_length.patch
  openssl-CVE-2007-3108-bug296511
  openssl-CVE-2007-5135.patch
  openssl-gcc42.patch
  openssl-gcc42_b.patch
  openssl-s390-config.diff
* Mon Oct  1 2007 mkoenig@suse.de
- fix buffer overflow CVE-2007-5135 [#329208]
* Wed Sep  5 2007 mkoenig@suse.de
- fix another gcc 4.2 build problem [#307669]
* Fri Aug  3 2007 coolo@suse.de
- provide the version obsoleted (#293401)
* Wed Aug  1 2007 werner@suse.de
- Add patch from CVS for RSA key reconstruction vulnerability
  (CVE-2007-3108, VU#724968, bug #296511)
* Thu May 24 2007 mkoenig@suse.de
- fix build with gcc-4.2
  openssl-gcc42.patch
- do not install example scripts with executable permissions
* Sun Apr 29 2007 ro@suse.de
- adapt requires
* Fri Apr 27 2007 mkoenig@suse.de
- Do not use dots in package name
- explicitly build with gcc-4.1 because of currently unresolved
  failures with gcc-4.2
* Wed Apr 25 2007 mkoenig@suse.de
- Split/rename package to follow library packaging policy [#260219]
  New package libopenssl0.9.8 containing shared libs
  openssl-devel package renamed to libopenssl-devel
  New package openssl-certs containing certificates
- add zlib-devel to Requires of devel package
- remove old Obsoletes and Conflicts
  openssls (Last used Nov 2000)
  ssleay (Last used 6.2)
* Mon Apr 23 2007 mkoenig@suse.de
- Fix key length [#254905,#262477]
* Tue Mar  6 2007 mkoenig@suse.de
- update to version 0.9.8e:
  * patches merged upstream:
    openssl-CVE-2006-2940-fixup.patch
    openssl-0.9.8d-padlock-static.patch
* Tue Jan  9 2007 mkoenig@suse.de
- fix PadLock support [#230823]
* Thu Nov 30 2006 mkoenig@suse.de
- enable fix for CVE-2006-2940 [#223040], SWAMP-ID 7198
* Mon Nov  6 2006 poeml@suse.de
- configure with 'zlib' instead of 'zlib-dynamic'. Build with the
  latter, there are problems opening the libz when running on the
  Via Epia or vmware platforms. [#213305]
* Wed Oct  4 2006 poeml@suse.de
- add patch for the CVE-2006-2940 fix: the newly introduced limit
  on DH modulus size could lead to a crash when exerted. [#208971]
  Discovered and fixed after the 0.9.8d release.
* Fri Sep 29 2006 poeml@suse.de
- update to 0.9.8d
  * ) Introduce limits to prevent malicious keys being able to
    cause a denial of service.  (CVE-2006-2940)
  * ) Fix ASN.1 parsing of certain invalid structures that can result
    in a denial of service.  (CVE-2006-2937)
  * ) Fix buffer overflow in SSL_get_shared_ciphers() function.
    (CVE-2006-3738)
  * ) Fix SSL client code which could crash if connecting to a
    malicious SSLv2 server.  (CVE-2006-4343)
  * ) Since 0.9.8b, ciphersuite strings naming explicit ciphersuites
    match only those.  Before that, "AES256-SHA" would be interpreted
    as a pattern and match "AES128-SHA" too (since AES128-SHA got
    the same strength classification in 0.9.7h) as we currently only
    have a single AES bit in the ciphersuite description bitmap.
    That change, however, also applied to ciphersuite strings such as
    "RC4-MD5" that intentionally matched multiple ciphersuites --
    namely, SSL 2.0 ciphersuites in addition to the more common ones
    from SSL 3.0/TLS 1.0.
    So we change the selection algorithm again: Naming an explicit
    ciphersuite selects this one ciphersuite, and any other similar
    ciphersuite (same bitmap) from *other* protocol versions.
    Thus, "RC4-MD5" again will properly select both the SSL 2.0
    ciphersuite and the SSL 3.0/TLS 1.0 ciphersuite.
    Since SSL 2.0 does not have any ciphersuites for which the
    128/256 bit distinction would be relevant, this works for now.
    The proper fix will be to use different bits for AES128 and
    AES256, which would have avoided the problems from the beginning;
    however, bits are scarce, so we can only do this in a new release
    (not just a patchlevel) when we can change the SSL_CIPHER
    definition to split the single 'unsigned long mask' bitmap into
    multiple values to extend the available space.
- not in mentioned in CHANGES: patch for CVE-2006-4339 corrected
  [openssl.org #1397]
* Fri Sep  8 2006 schwab@suse.de
- Fix inverted logic.
* Wed Sep  6 2006 poeml@suse.de
- update to 0.9.8c
  Changes between 0.9.8b and 0.9.8c  [05 Sep 2006]
  * ) Avoid PKCS #1 v1.5 signature attack discovered by Daniel Bleichenbacher
    (CVE-2006-4339)  [Ben Laurie and Google Security Team]
  * ) Add AES IGE and biIGE modes.  [Ben Laurie]
  * ) Change the Unix randomness entropy gathering to use poll() when
    possible instead of select(), since the latter has some
    undesirable limitations.  [Darryl Miles via Richard Levitte and Bodo Moeller]
  * ) Disable "ECCdraft" ciphersuites more thoroughly.  Now special
    treatment in ssl/ssl_ciph.s makes sure that these ciphersuites
    cannot be implicitly activated as part of, e.g., the "AES" alias.
    However, please upgrade to OpenSSL 0.9.9[-dev] for
    non-experimental use of the ECC ciphersuites to get TLS extension
    support, which is required for curve and point format negotiation
    to avoid potential handshake problems.  [Bodo Moeller]
  * ) Disable rogue ciphersuites:
  - SSLv2 0x08 0x00 0x80 ("RC4-64-MD5")
  - SSLv3/TLSv1 0x00 0x61 ("EXP1024-RC2-CBC-MD5")
  - SSLv3/TLSv1 0x00 0x60 ("EXP1024-RC4-MD5")
    The latter two were purportedly from
    draft-ietf-tls-56-bit-ciphersuites-0[01].txt, but do not really
    appear there.
    Also deactive the remaining ciphersuites from
    draft-ietf-tls-56-bit-ciphersuites-01.txt.  These are just as
    unofficial, and the ID has long expired.  [Bodo Moeller]
  * ) Fix RSA blinding Heisenbug (problems sometimes occured on
    dual-core machines) and other potential thread-safety issues.
    [Bodo Moeller]
  * ) Add the symmetric cipher Camellia (128-bit, 192-bit, 256-bit key
    versions), which is now available for royalty-free use
    (see http://info.isl.ntt.co.jp/crypt/eng/info/chiteki.html).
    Also, add Camellia TLS ciphersuites from RFC 4132.
    To minimize changes between patchlevels in the OpenSSL 0.9.8
    series, Camellia remains excluded from compilation unless OpenSSL
    is configured with 'enable-camellia'.  [NTT]
  * ) Disable the padding bug check when compression is in use. The padding
    bug check assumes the first packet is of even length, this is not
    necessarily true if compresssion is enabled and can result in false
    positives causing handshake failure. The actual bug test is ancient
    code so it is hoped that implementations will either have fixed it by
    now or any which still have the bug do not support compression.
    [Steve Henson]
  Changes between 0.9.8a and 0.9.8b  [04 May 2006]
  * ) When applying a cipher rule check to see if string match is an explicit
    cipher suite and only match that one cipher suite if it is.  [Steve Henson]
  * ) Link in manifests for VC++ if needed.  [Austin Ziegler <halostatue@gmail.com>]
  * ) Update support for ECC-based TLS ciphersuites according to
    draft-ietf-tls-ecc-12.txt with proposed changes (but without
    TLS extensions, which are supported starting with the 0.9.9
    branch, not in the OpenSSL 0.9.8 branch).  [Douglas Stebila]
  * ) New functions EVP_CIPHER_CTX_new() and EVP_CIPHER_CTX_free() to support
    opaque EVP_CIPHER_CTX handling.  [Steve Henson]
  * ) Fixes and enhancements to zlib compression code. We now only use
    "zlib1.dll" and use the default __cdecl calling convention on Win32
    to conform with the standards mentioned here:
    http://www.zlib.net/DLL_FAQ.txt
    Static zlib linking now works on Windows and the new --with-zlib-include
  - -with-zlib-lib options to Configure can be used to supply the location
    of the headers and library. Gracefully handle case where zlib library
    can't be loaded.  [Steve Henson]
  * ) Several fixes and enhancements to the OID generation code. The old code
    sometimes allowed invalid OIDs (1.X for X >= 40 for example), couldn't
    handle numbers larger than ULONG_MAX, truncated printing and had a
    non standard OBJ_obj2txt() behaviour.  [Steve Henson]
  * ) Add support for building of engines under engine/ as shared libraries
    under VC++ build system.  [Steve Henson]
  * ) Corrected the numerous bugs in the Win32 path splitter in DSO.
    Hopefully, we will not see any false combination of paths any more.
    [Richard Levitte]
- enable Camellia cipher. There is a royalty free license to the
  patents, see http://info.isl.ntt.co.jp/crypt/eng/info/chiteki.html.
  NOTE: the license forbids patches to the cipher.
- build with zlib-dynamic and add zlib-devel to BuildRequires.
  Allows compression of data in TLS, although few application would
  actually use it since there is no standard for negotiating the
  compression method. The only one I know if is stunnel.
* Fri Jun  2 2006 poeml@suse.de
- fix built-in ENGINESDIR for 64 bit architectures. We change only
  the builtin search path for engines, not the path where engines
  are packaged. Path can be overridden with the OPENSSL_ENGINES
  environment variable. [#179094]
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Mon Jan 16 2006 mc@suse.de
- fix build problems on s390x (openssl-s390-config.diff)
- build with -fstack-protector
* Mon Nov  7 2005 dmueller@suse.de
- build with non-executable stack
* Thu Oct 20 2005 poeml@suse.de
- fix unguarded free() which can cause a segfault in the ca
  commandline app [#128655]
* Thu Oct 13 2005 poeml@suse.de
- add Geotrusts Equifax Root1 CA certificate, which needed to
  verify the authenticity of you.novell.com [#121966]
* Tue Oct 11 2005 poeml@suse.de
- update to 0.9.8a
  * ) Remove the functionality of SSL_OP_MSIE_SSLV2_RSA_PADDING
    (part of SSL_OP_ALL).  This option used to disable the
    countermeasure against man-in-the-middle protocol-version
    rollback in the SSL 2.0 server implementation, which is a bad
    idea.  (CAN-2005-2969)
  * ) Add two function to clear and return the verify parameter flags.
  * ) Keep cipherlists sorted in the source instead of sorting them at
    runtime, thus removing the need for a lock.
  * ) Avoid some small subgroup attacks in Diffie-Hellman.
  * ) Add functions for well-known primes.
  * ) Extended Windows CE support.
  * ) Initialize SSL_METHOD structures at compile time instead of during
    runtime, thus removing the need for a lock.
  * ) Make PKCS7_decrypt() work even if no certificate is supplied by
    attempting to decrypt each encrypted key in turn. Add support to
    smime utility.
* Thu Sep 29 2005 poeml@suse.de
- update to 0.9.8
  see CHANGES file or http://www.openssl.org/news/changelog.html
- adjust patches
- drop obsolete openssl-no-libc.diff
- disable libica patch until it has been ported
* Fri May 20 2005 poeml@suse.de
- update to 0.9.7g. The significant changes are:
  * ) Fixes for newer kerberos headers. NB: the casts are needed because
    the 'length' field is signed on one version and unsigned on another
    with no (?) obvious way to tell the difference, without these VC++
    complains. Also the "definition" of FAR (blank) is no longer included
    nor is the error ENOMEM. KRB5_PRIVATE has to be set to 1 to pick up
    some needed definitions.
  * ) Added support for proxy certificates according to RFC 3820.
    Because they may be a security thread to unaware applications,
    they must be explicitely allowed in run-time.  See
    docs/HOWTO/proxy_certificates.txt for further information.
* Tue May 17 2005 schwab@suse.de
- Include %%cflags_profile_generate in ${CC} since it is required for
  linking as well.
- Remove explicit reference to libc.
* Fri Apr  8 2005 poeml@suse.de
- update to 0.9.7f. The most significant changes are:
    o Several compilation issues fixed.
    o Many memory allocation failure checks added.
    o Improved comparison of X509 Name type.
    o Mandatory basic checks on certificates.
    o Performance improvements.
  (for a complete list see http://www.openssl.org/source/exp/CHANGES)
- adjust openssl-0.9.7f-ppc64.diff
- drop obsolete openssl-0.9.7d-crl-default_md.dif [#55435]
* Tue Jan  4 2005 poeml@suse.de
- update to 0.9.7e
  * ) Avoid a race condition when CRLs are checked in a multi
    threaded environment. This would happen due to the reordering
    of the revoked entries during signature checking and serial
    number lookup. Now the encoding is cached and the serial
    number sort performed under a lock.  Add new STACK function
    sk_is_sorted().
  * ) Add Delta CRL to the extension code.
  * ) Various fixes to s3_pkt.c so alerts are sent properly.
  * ) Reduce the chances of duplicate issuer name and serial numbers
    (in violation of RFC3280) using the OpenSSL certificate
    creation utilities.  This is done by creating a random 64 bit
    value for the initial serial number when a serial number file
    is created or when a self signed certificate is created using
    'openssl req -x509'. The initial serial number file is created
    using 'openssl x509 -next_serial' in CA.pl rather than being
    initialized to 1.
- remove obsolete patches
- fix openssl-0.9.7d-padlock-glue.diff and ICA patch to patch
  Makefile, not Makefile.ssl
- fixup for spaces in names of man pages not needed now
- pack /usr/bin/openssl_fips_fingerprint
- in rpm post/postun script, run /sbin/ldconfig directly (the macro
  is deprecated)
* Mon Oct 18 2004 poeml@suse.de
- don't install openssl.doxy file [#45210]
* Thu Jul 29 2004 poeml@suse.de
- apply patch from CVS to fix segfault in S/MIME encryption
  (http://cvs.openssl.org/chngview?cn=12081, regression in
  openssl-0.9.7d) [#43386]
* Mon Jul 12 2004 mludvig@suse.cz
- Updated VIA PadLock engine.
* Wed Jun 30 2004 mludvig@suse.cz
- Updated openssl-0.9.7d-padlock-engine.diff with support for
  AES192, AES256 and RNG.
* Tue Jun 15 2004 poeml@suse.de
- update IBM ICA patch to last night's version. Fixes ibmca_init()
  to reset ibmca_dso=NULL after calling DSO_free(), if the device
  driver could not be loaded. The bug lead to a segfault triggered
  by stunnel, which does autoload available engines [#41874]
- patch from CVS: make stack API more robust (return NULL for
  out-of-range indexes). Fixes another possible segfault during
  engine detection (could also triggered by stunnel)
- add patch from Michal Ludvig for VIA PadLock support
* Wed Jun  2 2004 poeml@suse.de
- add root certificate for the ICP-Brasil CA [#41546]
* Thu May 13 2004 poeml@suse.de
- add patch to use default_md for CRLs too [#40435]
* Tue May  4 2004 poeml@suse.de
- update ICA patch to apr292004 release [#39695]
* Thu Mar 18 2004 poeml@suse.de
- update to 0.9.7d
  o Security: Fix Kerberos ciphersuite SSL/TLS handshaking bug
    (CAN-2004-0112)
  o Security: Fix null-pointer assignment in do_change_cipher_spec()
    (CAN-2004-0079)
  o Allow multiple active certificates with same subject in CA index
  o Multiple X590 verification fixes
  o Speed up HMAC and other operations
- remove the hunk from openssl-0.9.6d.dif that added NO_IDEA around
  IDEA_128_CBC_WITH_MD5 in the global cipher list. Upstream now has
  OPENSSL_NO_IDEA around it
- [#36386] fixed (broken generation of EVP_BytesToKey.3ssl from the
  pod file)
- permissions of lib/pkgconfig fixed
* Wed Feb 25 2004 poeml@suse.de
- update to 0.9.7c
  * ) Fix various bugs revealed by running the NISCC test suite:
    Stop out of bounds reads in the ASN1 code when presented with
    invalid tags (CAN-2003-0543 and CAN-2003-0544).
    Free up ASN1_TYPE correctly if ANY type is invalid (CAN-2003-0545).
    If verify callback ignores invalid public key errors don't try to check
    certificate signature with the NULL public key.
  * ) New -ignore_err option in ocsp application to stop the server
    exiting on the first error in a request.
  * ) In ssl3_accept() (ssl/s3_srvr.c) only accept a client certificate
    if the server requested one: as stated in TLS 1.0 and SSL 3.0
    specifications.
  * ) In ssl3_get_client_hello() (ssl/s3_srvr.c), tolerate additional
    extra data after the compression methods not only for TLS 1.0
    but also for SSL 3.0 (as required by the specification).
  * ) Change X509_certificate_type() to mark the key as exported/exportable
    when it's 512 *bits* long, not 512 bytes.
  * ) Change AES_cbc_encrypt() so it outputs exact multiple of
    blocks during encryption.
  * ) Various fixes to base64 BIO and non blocking I/O. On write
    flushes were not handled properly if the BIO retried. On read
    data was not being buffered properly and had various logic bugs.
    This also affects blocking I/O when the data being decoded is a
    certain size.
  * ) Various S/MIME bugfixes and compatibility changes:
    output correct application/pkcs7 MIME type if
    PKCS7_NOOLDMIMETYPE is set. Tolerate some broken signatures.
    Output CR+LF for EOL if PKCS7_CRLFEOL is set (this makes opening
    of files as .eml work). Correctly handle very long lines in MIME
    parser.
- update ICA patch
  quote: This version of the engine patch has updated error handling in
  the DES/SHA code, and turns RSA blinding off for hardware
  accelerated RSA ops.
- filenames of some man pages contain spaces now. Replace them with
  underscores
- fix compiler warnings in showciphers.c
- fix permissions of /usr/%%_lib/pkgconfig
* Sat Jan 10 2004 adrian@suse.de
- add %%run_ldconfig
- remove unneeded PreRequires
* Tue Nov 18 2003 poeml@suse.de
- ditch annoying mail to root about moved locations [#31969]
* Wed Aug 13 2003 poeml@suse.de
- enable profile feedback based optimizations (except AES which
  becomes slower)
- add -fno-strict-aliasing, due to warnings about code where
  dereferencing type-punned pointers will break strict aliasing
- make a readlink function if readlink is not available
* Mon Aug  4 2003 ro@suse.de
- fixed manpages symlinks
* Wed Jul 30 2003 meissner@suse.de
- Fix Makefile to create pkgconfig file with lib64 on lib64 systems.
* Sun Jul 27 2003 poeml@suse.de
- don't explicitely strip binaries since RPM handles it, and may
  keep the stripped information somewhere
* Tue Jul 15 2003 meissner@suse.de
- -DMD32_REG_T=int for ppc64 and s390x.
* Thu Jul 10 2003 poeml@suse.de
- update ibm ICA patch to 20030708 release (libica-1.3)
* Mon May 12 2003 poeml@suse.de
- package the openssl.pc file for pkgconfig
* Wed Apr 16 2003 poeml@suse.de
- update to 0.9.7b. The most significant changes are:
  o New library section OCSP.
  o Complete rewrite of ASN1 code.
  o CRL checking in verify code and openssl utility.
  o Extension copying in 'ca' utility.
  o Flexible display options in 'ca' utility.
  o Provisional support for international characters with UTF8.
  o Support for external crypto devices ('engine') is no longer
    a separate distribution.
  o New elliptic curve library section.
  o New AES (Rijndael) library section.
  o Support for new platforms: Windows CE, Tandem OSS, A/UX, AIX 64-bit,
    Linux x86_64, Linux 64-bit on Sparc v9
  o Extended support for some platforms: VxWorks
  o Enhanced support for shared libraries.
  o Now only builds PIC code when shared library support is requested.
  o Support for pkg-config.
  o Lots of new manuals.
  o Makes symbolic links to or copies of manuals to cover all described
    functions.
  o Change DES API to clean up the namespace (some applications link also
    against libdes providing similar functions having the same name).
    Provide macros for backward compatibility (will be removed in the
    future).
  o Unify handling of cryptographic algorithms (software and engine)
    to be available via EVP routines for asymmetric and symmetric ciphers.
  o NCONF: new configuration handling routines.
  o Change API to use more 'const' modifiers to improve error checking
    and help optimizers.
  o Finally remove references to RSAref.
  o Reworked parts of the BIGNUM code.
  o Support for new engines: Broadcom ubsec, Accelerated Encryption
    Processing, IBM 4758.
  o A few new engines added in the demos area.
  o Extended and corrected OID (object identifier) table.
  o PRNG: query at more locations for a random device, automatic query for
    EGD style random sources at several locations.
  o SSL/TLS: allow optional cipher choice according to server's preference.
  o SSL/TLS: allow server to explicitly set new session ids.
  o SSL/TLS: support Kerberos cipher suites (RFC2712).
    Only supports MIT Kerberos for now.
  o SSL/TLS: allow more precise control of renegotiations and sessions.
  o SSL/TLS: add callback to retrieve SSL/TLS messages.
  o SSL/TLS: support AES cipher suites (RFC3268).
- adapt the ibmca patch
- remove openssl-nocrypt.diff, openssl's crypt() vanished
- configuration syntax has changed ($sys_id added before $lflags)
* Thu Feb 20 2003 poeml@suse.de
- update to bugfix release 0.9.6i:
  - security fix: In ssl3_get_record (ssl/s3_pkt.c), minimize
    information leaked via timing by performing a MAC computation
    even if incorrrect block cipher padding has been found.  This
    is a countermeasure against active attacks where the attacker
    has to distinguish between bad padding and a MAC verification
    error.  (CAN-2003-0078)
  - a few more small bugfixes (mainly missing assertions)
* Fri Dec  6 2002 poeml@suse.de
- update to 0.9.6h (last release in the 0.9.6 series)
  o New configuration targets for Tandem OSS and A/UX.
  o New OIDs for Microsoft attributes.
  o Better handling of SSL session caching.
  o Better comparison of distinguished names.
  o Better handling of shared libraries in a mixed GNU/non-GNU environment.
  o Support assembler code with Borland C.
  o Fixes for length problems.
  o Fixes for uninitialised variables.
  o Fixes for memory leaks, some unusual crashes and some race conditions.
  o Fixes for smaller building problems.
  o Updates of manuals, FAQ and other instructive documents.
- add a call to make depend
- fix sed expression (lib -> lib64) to replace multiple occurences
  on one line
* Mon Nov  4 2002 stepan@suse.de
- fix openssl for alpha ev56 cpus
* Thu Oct 24 2002 poeml@suse.de
- own the /usr/share/ssl directory [#20849]
- openssl-hppa-config.diff can be applied on all architectures
* Mon Sep 30 2002 bg@suse.de
- enable hppa distribution; use only pa1.1 architecture.
* Tue Sep 17 2002 froh@suse.de
- update ibm-hardware-crypto-patch to ibmca.patch-0.96e-2 (#18953)
* Mon Aug 12 2002 poeml@suse.de
- update to 0.9.6g and drop the now included ASN1 check patch.
  Other change:
  - Use proper error handling instead of 'assertions' in buffer
    overflow checks added in 0.9.6e.  This prevents DoS (the
    assertions could call abort()).
* Fri Aug  9 2002 kukuk@suse.de
- Fix requires of openssl-devel subpackage
* Tue Aug  6 2002 draht@suse.de
- Correction for changes in the ASN1 code, assembled in
  openssl-0.9.6e-cvs-20020802-asn1_lib.diff
* Wed Jul 31 2002 poeml@suse.de
- update to 0.9.6e. Major changes:
  o Various security fixes (sanity checks to asn1_get_length(),
    various remote buffer overflows)
  o new option SSL_OP_DONT_INSERT_EMPTY_FRAGMENTS, disabling the
    countermeasure against a vulnerability in the CBC ciphersuites
    in SSL 3.0/TLS 1.0 that was added in 0.9.6d which turned out to
    be incompatible with buggy SSL implementations
- update ibmca crypto hardware patch (security issues fixed)
- gcc 3.1 version detection is fixed, we can drop the patch
- move the most used man pages from the -doc to the main package
  [#9913] and resolve man page conflicts by putting them into ssl
  sections [#17239]
- spec file: use PreReq for %%post script
* Fri Jul 12 2002 poeml@suse.de
- update to 0.9.6d. Major changes:
  o Various SSL/TLS library bugfixes.
  o Fix DH parameter generation for 'non-standard' generators.
  Complete Changelog: http://www.openssl.org/news/changelog.html
- supposed to fix a session caching failure occuring with postfix
- simplify local configuration for the architectures
- there's a new config variable: $shared_ldflag
- use RPM_OPT_FLAGS in favor of predifined cflags by appending them
  at the end
- validate config data (config --check-sanity)
- resolve file conflict of /usr/share/man/man1/openssl.1.gz [#15982]
- move configuration to /etc/ssl [#14387]
- mark openssl.cnf %%config (noreplace)
* Sat Jul  6 2002 schwab@suse.de
- Include <crypt.h> to get crypt prototype.
* Fri Jul  5 2002 kukuk@suse.de
- Remove crypt prototype from des.h header file, too.
* Mon Jun 10 2002 meissner@suse.de
- enhanced ppc64 support (needs seperate config), reenabled make check
* Fri May 31 2002 olh@suse.de
- add ppc64 support, temporary disable make check
* Thu Apr 18 2002 meissner@suse.de
- fixed x86_64 build, added bc to needed_for_build (used by tests)
* Wed Apr 17 2002 ro@suse.de
- fixed gcc version determination
- drop sun4c support/always use sparcv8
- ignore return code from showciphers
* Fri Mar 15 2002 poeml@suse.de
- add settings for sparc to build shared objects. Note that all
  sparcs (sun4[mdu]) are recognized as linux-sparcv7
* Wed Feb  6 2002 kukuk@suse.de
- Remove crypt function from libcrypto.so.0 [Bug #13056]
* Sun Feb  3 2002 poeml@suse.de
- add settings for mips to build shared objects
- print out all settings to the build log
* Tue Jan 29 2002 poeml@suse.de
- update to 0.9.6c:
  o bug fixes
  o support for hardware crypto devices (Cryptographic Appliances,
  Broadcom, and Accelerated Encryption Processing)
- add IBMCA patch for IBM eServer Cryptographic Accelerator Device
  Driver (#12565) (forward ported from 0.9.6b)
  (http://www-124.ibm.com/developerworks/projects/libica/)
- tell Configure how to build shared libs for s390 and s390x
- tweak Makefile.org to use %%_libdir
- clean up spec file
- add README.SuSE as source file instead of in a patch
* Wed Dec  5 2001 uli@suse.de
- disabled "make test" for ARM (destest segfaults, the other tests
  seem to succeed)
* Wed Dec  5 2001 ro@suse.de
- removed subpackage src
* Wed Nov 28 2001 uli@suse.de
- needs -ldl on ARM, too
* Mon Nov 19 2001 mls@suse.de
- made mips big endian, fixed shared library creation for mips
* Fri Aug 31 2001 rolf@suse.de
- added root certificates [BUG#9913]
- move from /usr/ssh to /usr/share/ssl
* Wed Jul 18 2001 rolf@suse.de
- update to 0.9.6b
- switch to engine version of openssl, which supports hardware
  encryption for a few popular devices
- check wether shared libraries have been generated
* Thu Jul  5 2001 rolf@suse.de
- appliy PRNG security patch
* Tue Jun 12 2001 bk@suse.de
- added support for s390x
* Mon May  7 2001 kukuk@suse.de
- Fix building of shared libraries on SPARC, too.
* Mon May  7 2001 rolf@suse.de
- Fix ppc and s390 shared library builds
- resolved conflict in manpage naming:
  rand.3 is now sslrand.3 [BUG#7643]
* Tue May  1 2001 schwab@suse.de
- Fix ia64 configuration.
- Fix link command.
* Thu Apr 26 2001 bjacke@suse.de
- updated to 0.96a
* Wed Apr 18 2001 kkaempf@suse.de
- provide .so files in -devel package only
* Tue Apr 17 2001 bjacke@suse.de
- resolve file name conflict (#6966)
* Wed Mar 21 2001 rolf@suse.de
- new subpackage openssl-src [BUG#6383]
- added README.SuSE which explains where to find the man pages [BUG#6717]
* Fri Dec 15 2000 sf@suse.de
- changed CFLAG to -O1 to make the tests run successfully
* Mon Dec 11 2000 rolf@suse.de
- build openssl with no-idea and no-rc5 to meet US & RSA regulations
- build with -fPIC on all platforms (especially IA64)
* Wed Nov 22 2000 rolf@suse.de
- rename openssls to openssl-devel and add shared libs and header files
- new subpackge openssl-doc for manpages and documentation
- use BuildRoot
* Fri Oct 27 2000 schwab@suse.de
- Add link-time links for libcrypto and libssl.
- Make sure that LD_LIBRARY_PATH is passed down to sub-makes.
* Mon Oct  2 2000 rolf@suse.de
- update to 0.9.6
* Mon Apr 10 2000 bk@suse.de
- fix support for s390-linux
* Mon Apr 10 2000 rolf@suse.de
- new version 0.9.5a
* Sun Apr  9 2000 bk@suse.de
- add support for s390-linux
* Mon Mar 27 2000 kukuk@suse.de
- Use sparcv7 for SPARC
* Wed Mar  1 2000 rolf@suse.de
- move manpages back, as too many conflict with system manuals
* Wed Mar  1 2000 rolf@suse.de
- move manpages to %%{_mandir}
- include static libraries
* Wed Mar  1 2000 bk@suse.de
- added subpackage source openssls, needed for ppp_ssl
* Tue Feb 29 2000 rolf@suse.de
- new version 0.9.5
* Thu Feb 24 2000 schwab@suse.de
- add support for ia64-linux
* Mon Jan 31 2000 kukuk@suse.de
- Create and add libcrypto.so.0 and libssl.so.0
* Mon Sep 13 1999 bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Wed Sep  1 1999 rolf@suse.de
- new version 0.9.4
* Wed May 26 1999 rolf@suse.de
- new version 0.9.3 with new layout
- alpha asm disabled by default now, no patch needed
* Thu May 20 1999 ro@suse.de
- disable asm for alpha: seems incomplete
* Mon May 17 1999 rolf@suse.de
- don't use -DNO_IDEA
* Wed May 12 1999 rolf@suse.de
- first version 0.9.2b
